Imports System.Xml
Public Class BeschriftungsRechteck
    Private m_Text As String = ""
    Private m_Left As Integer = 0
    Private m_Top As Integer = 0
    Private m_Width As Integer = 100
    Private m_Height As Integer = 100
    Public Event Changed()
    Property Text() As String
        Get
            Return m_Text
        End Get
        Set(ByVal value As String)
            m_Text = value
            RaiseEvent Changed()
        End Set
    End Property
    Property Left() As Integer
        Get
            Return m_Left
        End Get
        Set(ByVal value As Integer)
            m_Left = value
            RaiseEvent Changed()
        End Set
    End Property
    Property Top() As Integer
        Get
            Return m_Top
        End Get
        Set(ByVal value As Integer)
            m_Top = value
            RaiseEvent Changed()
        End Set
    End Property
    Property Width() As Integer
        Get
            Return m_Width
        End Get
        Set(ByVal value As Integer)
            m_Width = value
            RaiseEvent Changed()
        End Set
    End Property
    Property Height() As Integer
        Get
            Return m_Height
        End Get
        Set(ByVal value As Integer)
            m_Height = value
            RaiseEvent Changed()
        End Set
    End Property
    Property Rect() As Rectangle
        Get
            Return New Rectangle(m_Left, m_Top, m_Width, m_Height)
        End Get
        Set(ByVal value As Rectangle)
            m_Left = value.Left
            m_Top = value.Top
            m_Width = value.Width
            m_Height = value.Height
            RaiseEvent Changed()
        End Set
    End Property
    Public Sub New(ByVal Text As String)
        m_Text = Text
    End Sub
    Public Sub New(ByVal Nd As XmlNode)
        m_Left = CInt(Nd.Attributes("Left").Value)
        m_Top = CInt(Nd.Attributes("Top").Value)
        m_Width = CInt(Nd.Attributes("Width").Value)
        m_Height = CInt(Nd.Attributes("Height").Value)
        m_Text = Nd.Attributes("Text").Value
    End Sub
    Public Sub Write_XML(ByVal writer As XmlTextWriter)
        writer.WriteStartElement("Beschriftung")
        writer.WriteAttributeString("Text", m_Text)
        writer.WriteAttributeString("Left", m_Left.ToString)
        writer.WriteAttributeString("Top", m_Top.ToString)
        writer.WriteAttributeString("Width", m_Width.ToString)
        writer.WriteAttributeString("Height", m_Height.ToString)
        writer.WriteEndElement()
    End Sub
    Public Function HitTest(ByVal Pt As PointF) As BeschriftungsRechteckHitTestResults
        If (Pt.X > m_Left - 3) AndAlso (Pt.X < m_Left + m_Width + 3) Then
            'Bewegung innerhalb des X-Bereiches des Rechtecks
            If (Pt.Y > m_Top - 3) AndAlso (Pt.Y < m_Top + m_Height + 3) Then
                If (Pt.X > m_Left - 3) AndAlso (Pt.X < m_Left + 3) Then
                    Return BeschriftungsRechteckHitTestResults.Left
                ElseIf (Pt.X > m_Left + m_Width - 3) AndAlso (Pt.X < m_Left + m_Width + 3) Then
                    Return BeschriftungsRechteckHitTestResults.Right
                End If
            End If

            If (Pt.Y > m_Top - 3) AndAlso (Pt.Y < m_Top + 3) Then
                Return BeschriftungsRechteckHitTestResults.Top
            ElseIf (Pt.Y > m_Top + m_Height - 3) AndAlso (Pt.Y < m_Top + m_Height + 3) Then
                Return BeschriftungsRechteckHitTestResults.Bottom
            ElseIf (Pt.Y > m_Top - 3) AndAlso (Pt.Y < m_Top + 3 + 15) Then
                Return BeschriftungsRechteckHitTestResults.MoveArea
            End If
        End If
        Return BeschriftungsRechteckHitTestResults.None
    End Function
End Class
