Imports System.Xml
Public Class Bild
    Private m_Filename As String = ""
    Private m_Beschreibung As String = ""
    Private WithEvents m_Autor As Autor = StandardAutor
    Private m_QuellIndex As String = ""
    Private m_Size As Size = Size.Empty
    Private WithEvents m_Beschriftungen As New BeschriftungsRechteckListe

    Private m_Datumsangabe As IDatumsAngabe = UnbekanntDatumsAngabe
    Public Event Changed()
    Public Event RemoveMeFromControls()
    Public Event ThumbChanged()
    ReadOnly Property Size() As Size
        Get
            Return m_Size
        End Get
    End Property
    ReadOnly Property Beschriftungen() As BeschriftungsRechteckListe
        Get
            Return m_Beschriftungen
        End Get
    End Property
    Property Datumsangabe() As IDatumsAngabe
        Get
            Return m_Datumsangabe
        End Get
        Set(ByVal value As IDatumsAngabe)
            If m_Datumsangabe IsNot value Then
                m_Datumsangabe = value
                RaiseEvent Changed()
            End If
        End Set
    End Property

    Property QuellIndex() As String
        Get
            Return m_QuellIndex
        End Get
        Set(ByVal value As String)
            If m_QuellIndex <> value Then
                m_QuellIndex = value
                RaiseEvent Changed()
            End If
        End Set
    End Property

    Property Autor() As Autor
        Get
            Return m_Autor
        End Get
        Set(ByVal value As Autor)
            If m_Autor IsNot value Then
                m_Autor = value
                RaiseEvent Changed()
            End If
        End Set
    End Property
    Property FileName() As String
        Get
            Return m_Filename
        End Get
        Set(ByVal value As String)
            m_Filename = value
        End Set
    End Property

    Public ReadOnly Property Pfad() As String
        Get
            If m_Filename.IndexOf("\") > -1 Then
                Return m_Filename
            Else
                Return BildOrdnerPfad & "\" & m_Filename
            End If
        End Get
    End Property

    Public Function ThumbFileName() As String
        Dim DateiName As String = IO.Path.GetFileNameWithoutExtension(BildOrdnerPfad & "\" & m_Filename)
        Return ThumbOrdnerPfad & "\" & DateiName & ".jpg"
    End Function

    Property Beschreibung() As String
        Get
            Return m_Beschreibung
        End Get
        Set(ByVal value As String)
            If m_Beschreibung <> value Then
                m_Beschreibung = value
                RaiseEvent Changed()
            End If
        End Set
    End Property
    Public Sub New(ByVal FileName As String)
        m_Filename = FileName
        AddHandler m_Beschriftungen.Changed, AddressOf m_Beschriftungen_Changed
    End Sub

    Public Sub New(ByVal Nd As XmlNode, ByVal Autoren As List(Of Autor), ByVal Datumsangaben As List(Of IDatumsAngabe))
        m_Filename = Nd.Attributes("Filename").Value
        m_Beschreibung = Nd.Attributes("Beschreibung").Value
        m_Autor = Autoren(CInt(Nd.Attributes("Autor").Value))
        m_QuellIndex = Nd.Attributes("QuellIndex").Value
        m_Datumsangabe = Datumsangaben(CInt(Nd.Attributes("Datumsangabe").Value))
        For Each Att As XmlAttribute In Nd.Attributes
            If Att.Name = "Width" Then
                m_Size = New Size(CInt(Nd.Attributes("Width").Value), CInt(Nd.Attributes("Height").Value))
                Exit For
            End If
        Next
        For Each xNd As XmlNode In Nd.ChildNodes
            If xNd.Name = "Beschriftung" Then
                m_Beschriftungen.Add(New BeschriftungsRechteck(xNd))
            End If
        Next
        AddHandler m_Beschriftungen.Changed, AddressOf m_Beschriftungen_Changed
    End Sub

    Public Sub Write_XML(ByVal writer As XmlTextWriter, ByVal Autoren As List(Of Autor), ByVal Datumsangaben As List(Of IDatumsAngabe))
        writer.WriteAttributeString("Filename", m_Filename)
        writer.WriteAttributeString("Beschreibung", m_Beschreibung)
        writer.WriteAttributeString("Autor", Autoren.IndexOf(m_Autor).ToString)
        writer.WriteAttributeString("QuellIndex", m_QuellIndex)
        writer.WriteAttributeString("Datumsangabe", Datumsangaben.IndexOf(m_Datumsangabe).ToString)
        writer.WriteAttributeString("Width", m_Size.Width.ToString)
        writer.WriteAttributeString("Height", m_Size.Height.ToString)
        For Each Beschr As BeschriftungsRechteck In m_Beschriftungen
            Beschr.Write_XML(writer)
        Next
    End Sub
    Public Sub RemoveFromLists()
        RaiseEvent RemoveMeFromControls()
    End Sub

    Public Sub RemoveFiles()
        Dim SF As String = ThumbFileName()
        If IO.File.Exists(SF) Then
            IO.File.Delete(SF)
        End If
        IO.File.Delete(Pfad)
    End Sub

    Private Sub m_Autor_Changed() Handles m_Autor.Changed
        RaiseEvent Changed()
    End Sub
    Public Sub CheckCreateThumb(ByVal Liste As DatumsangabeListe)
        Dim ThumbName As String = ThumbFileName()
        If Not IO.File.Exists(ThumbName) Then
            Dim Img As Image = Image.FromFile(Me.Pfad)

            For Each Itm As Drawing.Imaging.PropertyItem In Img.PropertyItems
                'Exif-Erstellungsdatum
                If Itm.Id = &H132 Then
                    Dim encoding As New System.Text.ASCIIEncoding()
                    'MsgBox(encoding.GetString(Itm.Value))
                    Try
                        Dim Txt As String = encoding.GetString(Itm.Value)
                        Dim Teile() As String = Txt.Split(" ")
                        Dim Txte() As String = Teile(0).Split(":")
                        Dim Txta() As String = Teile(1).Split(":")

                        Dim Zeit As DateTime = New DateTime(CInt(Txte(0)), CInt(Txte(1)), CInt(Txte(2)), CInt(Txta(0)), CInt(Txta(1)), CInt(Txta(2)))
                        Liste.SetDatumForBild(New DatumsAngabeExifZeit(Zeit), Me)
                    Catch ex As Exception

                    End Try

                End If
            Next
            m_Size = Img.Size

            Dim NewRect As Rectangle = GetPictureRectangle(New Rectangle(0, 0, 400, 400), Img.Size)
            Dim Thumb As New Bitmap(NewRect.Width, NewRect.Height)
            Dim g As Graphics = Graphics.FromImage(Thumb)
            g.DrawImage(Img, New Rectangle(0, 0, NewRect.Width, NewRect.Height))

            Dim enc As Imaging.ImageCodecInfo = Nothing
            Dim Infos() As Imaging.ImageCodecInfo = Imaging.ImageCodecInfo.GetImageEncoders
            For Each Inf As Imaging.ImageCodecInfo In Infos
                If Inf.MimeType.ToLower = "image/jpeg" Then
                    enc = Inf
                    Exit For
                End If
            Next
            Dim Params As New Imaging.EncoderParameters(1)
            Params.Param(0) = New Imaging.EncoderParameter(Imaging.Encoder.Quality, 30L)
            Thumb.Save(ThumbName, enc, Params)
            Thumb.Dispose()
            Img.Dispose()
            RaiseEvent ThumbChanged()

        End If
    End Sub

    Private Sub m_Beschriftungen_Changed()
        RaiseEvent Changed()
    End Sub
End Class

