Imports System.Xml
Public Class BildGruppe
    Inherits List(Of Bild)
    Private m_Word As String = ""
    Private m_Description As String = ""
    Private m_IsToPublish As Boolean = False
    Public Event Changed()
    Property IsToPublish() As Boolean
        Get
            Return m_IsToPublish
        End Get
        Set(ByVal value As Boolean)
            If m_IsToPublish <> value Then
                m_IsToPublish = value
                RaiseEvent Changed()
            End If
        End Set
    End Property
    Property Description() As String
        Get
            Return m_Description
        End Get
        Set(ByVal value As String)
            If m_Description <> value Then
                m_Description = value
                RaiseEvent Changed()
            End If
        End Set
    End Property
    Property Word() As String
        Get
            Return m_Word
        End Get
        Set(ByVal value As String)
            If m_Word <> value Then
                m_Word = value
                RaiseEvent Changed()
            End If
        End Set
    End Property
    Public Sub New(ByVal Word As String)
        m_Word = Word
    End Sub
    Public Sub New(ByVal Nd As XmlNode, ByVal Bilder As List(Of Bild))
        m_Word = Nd.Attributes("Word").Value
        Dim Bildstr As String = Nd.Attributes("Bilder").Value
        If Bildstr <> "" Then
            Dim Teile() As String = Bildstr.Split(",")
            For Each txt As String In Teile
                Me.Add(Bilder.Item(CInt(txt)))
            Next
        End If
        'For Each Att As XmlAttribute In Nd.Attributes
        '    If Att.Name = "Description" Then
        '        m_Description = Att.Value
        '    ElseIf Att.Name = "IsToPublish" Then
        '        m_IsToPublish = CBool(Att.Value)
        '    End If
        'Next
        m_Description = Nd.Attributes("Description").Value
        m_IsToPublish = CBool(Nd.Attributes("IsToPublish").Value)
    End Sub
    Public Sub Write_XML(ByVal writer As XmlTextWriter, ByVal Bilder As List(Of Bild))
        writer.WriteAttributeString("Word", m_Word)
        If Me.Count = 0 Then
            writer.WriteAttributeString("Bilder", "")
        Else
            Dim Texte As New List(Of String)
            For Each Bld As Bild In Me
                Texte.Add(Bilder.IndexOf(Bld).ToString)
            Next
            Dim txt() As String = Texte.ToArray
            Dim JoinedTxt As String = Join(txt, ",")
            writer.WriteAttributeString("Bilder", JoinedTxt)
        End If
        writer.WriteAttributeString("Description", m_Description)
        writer.WriteAttributeString("IsToPublish", m_IsToPublish.ToString)
    End Sub

    Public Overrides Function ToString() As String
        Return m_Word
    End Function

End Class
