Imports System.Xml
Public Class DatumsAngabeExakt
    Implements IDatumsAngabe
    Private m_Tag As Integer = 1
    Private m_Month As Integer = 1
    Private m_Year As Integer = DateTime.Now.Year

    Public Function CreateClone() As DatumsAngabeExakt
        Return New DatumsAngabeExakt(New Date(m_Year, m_Month, m_Tag))
    End Function

    Public Function ToDatum() As Date Implements IDatumsAngabe.ToDatum
        Return New Date(m_Year, m_Month, m_Tag)
    End Function

    Public Overrides Function ToString() As String Implements IDatumsAngabe.ToString
        Dim Datum As New Date(m_Year, m_Month, m_Tag)
        Return Datum.ToShortDateString
    End Function

    Public ReadOnly Property Typ() As DatumsangabeTypen Implements IDatumsAngabe.Typ
        Get
            Return DatumsangabeTypen.Exakt
        End Get
    End Property
    Public Sub New(ByVal Datum As Date)
        m_Tag = Datum.Day
        m_Month = Datum.Month
        m_Year = Datum.Year
    End Sub
    Public Sub New(ByVal Nd As XmlNode)
        m_Tag = CInt(Nd.Attributes("Day").Value)
        m_Month = CInt(Nd.Attributes("Month").Value)
        m_Year = CInt(Nd.Attributes("Year").Value)
    End Sub
    Public Sub Write_XML(ByVal writer As XmlTextWriter) Implements IDatumsAngabe.Write_XML
        writer.WriteStartElement("DatumExakt")
        writer.WriteAttributeString("Day", m_Tag.ToString)
        writer.WriteAttributeString("Month", m_Month.ToString)
        writer.WriteAttributeString("Year", m_Year.ToString)
        writer.WriteEndElement()
    End Sub



    Public Function IstGleich(ByVal Vergleichsangabe As IDatumsAngabe) As Boolean Implements IDatumsAngabe.IstGleich
        If Vergleichsangabe.Typ <> Me.Typ Then
            Return False
        Else
            Dim VGA As DatumsAngabeExakt = Vergleichsangabe
            If VGA.ToDatum = Me.ToDatum Then
                Return True
            Else
                Return False
            End If
        End If
    End Function
End Class
