Imports System.Xml
Public Class DatumsAngabeExifZeit
    Implements IDatumsAngabe
    Private m_Datum As DateTime
    Public Function IstGleich(ByVal Vergleichsangabe As IDatumsAngabe) As Boolean Implements IDatumsAngabe.IstGleich
        If Vergleichsangabe.Typ <> Me.Typ Then
            Return False
        Else
            Dim VGA As DatumsAngabeExifZeit = Vergleichsangabe
            If VGA.ToDatum = Me.ToDatum Then
                Return True
            Else
                Return False
            End If
        End If
    End Function

    Public Function ToDatum() As Date Implements IDatumsAngabe.ToDatum
        Return m_Datum
    End Function

    Public Overrides Function ToString() As String Implements IDatumsAngabe.ToString
        Return m_Datum.ToShortDateString & " " & m_Datum.ToShortTimeString
    End Function

    Public ReadOnly Property Typ() As DatumsangabeTypen Implements IDatumsAngabe.Typ
        Get
            Return DatumsangabeTypen.ExifZeit
        End Get
    End Property

    Public Sub New(ByVal Datum As Date)
        m_Datum = Datum
    End Sub
    Public Sub New(ByVal Nd As XmlNode)
        m_Datum = DateTime.Parse(Nd.Attributes("Datum").Value)
    End Sub
    Public Sub Write_XML(ByVal writer As XmlTextWriter) Implements IDatumsAngabe.Write_XML
        writer.WriteStartElement("DatumExifZeit")
        writer.WriteAttributeString("Datum", m_Datum.ToString)
        writer.WriteEndElement()
    End Sub
    Public Function CreateClone() As DatumsAngabeExifZeit
        Return New DatumsAngabeExifZeit(m_Datum)
    End Function
End Class
