Imports System.Xml
Public Class DatumsAngabeJahr
    Implements IDatumsAngabe

    Private m_Jahr As Integer = Date.Today.Year

    Public Function CreateClone() As DatumsAngabeJahr
        Return New DatumsAngabeJahr(m_Jahr)
    End Function

    Public Function ToDatum() As Date Implements IDatumsAngabe.ToDatum
        Return New Date(m_Jahr, 6, 1)
    End Function

    Public Overrides Function ToString() As String Implements IDatumsAngabe.ToString
        Return m_Jahr.ToString
    End Function

    Public ReadOnly Property Typ() As DatumsangabeTypen Implements IDatumsAngabe.Typ
        Get
            Return DatumsangabeTypen.Jahr
        End Get
    End Property

    Public Sub New(ByVal Jahr As Integer)
        m_Jahr = Jahr
    End Sub
    Public Sub New(ByVal Nd As XmlNode)
        m_Jahr = CInt(Nd.Attributes("Year").Value)
    End Sub
    Public Sub Write_XML(ByVal writer As XmlTextWriter) Implements IDatumsAngabe.Write_XML
        writer.WriteStartElement("Jahr")
        writer.WriteAttributeString("Year", m_Jahr.ToString)
        writer.WriteEndElement()
    End Sub

    Public Function IstGleich(ByVal Vergleichsangabe As IDatumsAngabe) As Boolean Implements IDatumsAngabe.IstGleich
        If Vergleichsangabe.Typ <> Me.Typ Then
            Return False
        Else
            Dim VGA As DatumsAngabeJahr = Vergleichsangabe
            If VGA.ToDatum = Me.ToDatum Then
                Return True
            Else
                Return False
            End If
        End If
    End Function
End Class
