Imports System.Xml
Public Class DatumsAngabeJahreszeit
    Implements IDatumsAngabe


    Private m_Jahreszeit As Jahreszeiten = Jahreszeiten.Sommer
    Private m_Year As Integer = DateTime.Now.Year
    ReadOnly Property Jahreszeit() As Jahreszeiten
        Get
            Return m_Jahreszeit
        End Get
    End Property
    Public Function CreateClone() As DatumsAngabeJahreszeit
        Return New DatumsAngabeJahreszeit(m_Jahreszeit, m_Year)
    End Function

    Public Function ToDatum() As Date Implements IDatumsAngabe.ToDatum
        Select Case m_Jahreszeit
            Case Jahreszeiten.Frhling
                Return New Date(m_Year, 5, 15)
            Case Jahreszeiten.Sommer
                Return New Date(m_Year, 8, 15)
            Case Jahreszeiten.Herbst
                Return New Date(m_Year, 11, 15)
            Case Else
                Return New Date(m_Year, 2, 15)
        End Select
    End Function

    Public Overrides Function ToString() As String Implements IDatumsAngabe.ToString
        Return m_Jahreszeit.ToString & " " & m_Year.ToString
    End Function

    Public ReadOnly Property Typ() As DatumsangabeTypen Implements IDatumsAngabe.Typ
        Get
            Return DatumsangabeTypen.Jahreszeit
        End Get
    End Property

    Public Sub New(ByVal JZ As Jahreszeiten, ByVal Jahr As Integer)
        m_Jahreszeit = JZ
        m_Year = Jahr
    End Sub
    Public Sub New(ByVal Nd As XmlNode)
        m_Jahreszeit = CType(CInt(Nd.Attributes("Jahreszeit").Value), Jahreszeiten)
        m_Year = CInt(Nd.Attributes("Year").Value)
    End Sub
    Public Sub Write_XML(ByVal writer As XmlTextWriter) Implements IDatumsAngabe.Write_XML
        writer.WriteStartElement("Jahreszeit")
        writer.WriteAttributeString("Jahreszeit", CInt(m_Jahreszeit).ToString)
        writer.WriteAttributeString("Year", m_Year.ToString)
        writer.WriteEndElement()
    End Sub

    Public Function IstGleich(ByVal Vergleichsangabe As IDatumsAngabe) As Boolean Implements IDatumsAngabe.IstGleich
        If Vergleichsangabe.Typ <> Me.Typ Then
            Return False
        Else
            Dim VGA As DatumsAngabeJahreszeit = Vergleichsangabe
            If VGA.ToDatum = Me.ToDatum Then
                Return True
            Else
                Return False
            End If
        End If
    End Function
End Class
