Imports System.Xml
Public Class DatumsAngabeJahrzehnt
    Implements IDatumsAngabe


    Private m_Jahr As Integer = (DateTime.Now.Year \ 10) * 10
    Public Function CreateClone() As DatumsAngabeJahrzehnt
        Return New DatumsAngabeJahrzehnt(m_Jahr)
    End Function
    ReadOnly Property Jahr() As Integer
        Get
            Return m_Jahr
        End Get
    End Property

    Public Function ToDatum() As Date Implements IDatumsAngabe.ToDatum
        Return New Date(m_Jahr + 5, 1, 1)
    End Function

    Public Overrides Function ToString() As String Implements IDatumsAngabe.ToString
        Return "zwischen " & m_Jahr.ToString & " und " & (m_Jahr + 10).ToString
    End Function

    Public ReadOnly Property Typ() As DatumsangabeTypen Implements IDatumsAngabe.Typ
        Get
            Return DatumsangabeTypen.Jahrzehnt
        End Get
    End Property

    Public Sub New(ByVal Jahr As Integer)
        m_Jahr = (Jahr \ 10) * 10
    End Sub
    Public Sub New(ByVal Nd As XmlNode)
        m_Jahr = CInt(Nd.Attributes("Year").Value)
    End Sub
    Public Sub Write_XML(ByVal writer As XmlTextWriter) Implements IDatumsAngabe.Write_XML
        writer.WriteStartElement("Jahrzehnt")
        writer.WriteAttributeString("Year", m_Jahr.ToString)
        writer.WriteEndElement()
    End Sub

    Public Function IstGleich(ByVal Vergleichsangabe As IDatumsAngabe) As Boolean Implements IDatumsAngabe.IstGleich
        If Vergleichsangabe.Typ <> Me.Typ Then
            Return False
        Else
            Dim VGA As DatumsAngabeJahrzehnt = Vergleichsangabe
            If VGA.ToDatum = Me.ToDatum Then
                Return True
            Else
                Return False
            End If
        End If
    End Function
End Class
