Imports System.Xml
Public Class DatumsAngabeMonat
    Implements IDatumsAngabe


    Private m_Monat As Monate = Monate.Januar
    Private m_Year As Integer = DateTime.Now.Year

    Public Function CreateClone() As DatumsAngabeMonat
        Return New DatumsAngabeMonat(m_Monat, m_Year)
    End Function

    Public Function ToDatum() As Date Implements IDatumsAngabe.ToDatum
        Return New Date(m_Year, CInt(m_Monat), 15)
    End Function

    Public Overrides Function ToString() As String Implements IDatumsAngabe.ToString
        Return m_Monat.ToString & " " & m_Year.ToString
    End Function

    Public ReadOnly Property Typ() As DatumsangabeTypen Implements IDatumsAngabe.Typ
        Get
            Return DatumsangabeTypen.Monat
        End Get
    End Property

    Public Sub New(ByVal Monat As Monate, ByVal Jahr As Integer)
        m_Monat = Monat
        m_Year = Jahr
    End Sub
    Public Sub New(ByVal Nd As XmlNode)
        m_Monat = CType(CInt(Nd.Attributes("Month").Value), Monate)
        m_Year = CInt(Nd.Attributes("Year").Value)
    End Sub
    Public Sub Write_XML(ByVal writer As XmlTextWriter) Implements IDatumsAngabe.Write_XML
        writer.WriteStartElement("JahrMonat")
        writer.WriteAttributeString("Month", CInt(m_Monat).ToString)
        writer.WriteAttributeString("Year", m_Year.ToString)
        writer.WriteEndElement()
    End Sub

    Public Function IstGleich(ByVal Vergleichsangabe As IDatumsAngabe) As Boolean Implements IDatumsAngabe.IstGleich
        If Vergleichsangabe.Typ <> Me.Typ Then
            Return False
        Else
            Dim VGA As DatumsAngabeMonat = Vergleichsangabe
            If VGA.ToDatum = Me.ToDatum Then
                Return True
            Else
                Return False
            End If
        End If
    End Function
End Class
