Public Class BeschriftungsRechteckEditor
    Private WithEvents m_Rechtecke As BeschriftungsRechteckListe
    Private m_Initialisierung As Boolean = False
    Public Sub Init(ByVal BRs As BeschriftungsRechteckListe)
        m_Initialisierung = True

        m_Rechtecke = BRs
        ListViewRechtecke.Items.Clear()
        If m_Rechtecke Is Nothing Then Exit Sub

        For Each BR As BeschriftungsRechteck In m_Rechtecke
            Me.ListViewRechtecke.Items.Add(New BeschriftungsRechteckListViewItem(BR))
        Next
        If m_Rechtecke.SelectedRE IsNot Nothing Then
            For Each LVI As BeschriftungsRechteckListViewItem In ListViewRechtecke.Items
                If LVI.BeschriftungsRechteck Is m_Rechtecke.SelectedRE Then
                    LVI.Selected = True
                    Exit For
                End If
            Next
        End If

        CorrectCommandPanel()

        m_Initialisierung = False
    End Sub
    Private Sub CorrectCommandPanel()
        'dient nur der einstellung der CommandPanel-Eigenschaften

        If m_Rechtecke.SelectedRE Is Nothing Then
            Me.CommandPanel1.ButtonDelete.Enabled = False
            Me.CommandPanel1.ButtonEdit.Enabled = False
            Me.CommandPanel1.ButtonMoveDown.Enabled = False
            Me.CommandPanel1.ButtonMoveUp.Enabled = False
        Else
            Me.CommandPanel1.ButtonDelete.Enabled = True
            Me.CommandPanel1.ButtonEdit.Enabled = True

            If m_Rechtecke.IndexOf(m_Rechtecke.SelectedRE) = 0 Then
                Me.CommandPanel1.ButtonMoveUp.Enabled = False
            Else
                Me.CommandPanel1.ButtonMoveUp.Enabled = True
            End If
            If m_Rechtecke.IndexOf(m_Rechtecke.SelectedRE) = m_Rechtecke.Count - 1 Then
                Me.CommandPanel1.ButtonMoveDown.Enabled = False
            Else
                Me.CommandPanel1.ButtonMoveDown.Enabled = True
            End If
        End If

    End Sub

    Private Sub ListViewRechtecke_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ListViewRechtecke.SelectedIndexChanged
        If m_Initialisierung Then Exit Sub

        Dim RE As BeschriftungsRechteck = Nothing
        If Me.ListViewRechtecke.SelectedItems.Count > 0 Then
            Dim BGLVI As BeschriftungsRechteckListViewItem = ListViewRechtecke.SelectedItems(0)
            RE = BGLVI.BeschriftungsRechteck
        End If

        If m_Rechtecke.SelectedRE IsNot RE Then
            m_Rechtecke.SetSelected(RE, Me)
        End If

        CorrectCommandPanel()

    End Sub


    Private Sub BeschriftungsRechteckEditor_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Me.CommandPanel1.ButtonMoveLeft.Visible = False
        Me.CommandPanel1.ButtonMoveRight.Visible = False
        Me.CommandPanel1.ButtonMoveDown.Left = 2
        Me.CommandPanel1.ButtonMoveUp.Left = 28
        Me.CommandPanel1.ButtonEdit.Enabled = False = False
    End Sub

    Private Sub CommandPanel1_AddNew() Handles CommandPanel1.AddNew

        Dim Text As String = InputBox("Bitte neuen Namen angeben", "PhotoCollector", "")
        Text = Text.Trim
        If Text <> "" Then
            Dim BG As New BeschriftungsRechteck(Text)
            m_Rechtecke.Add(BG)
            Dim BGLVI As New BeschriftungsRechteckListViewItem(BG)
            Me.ListViewRechtecke.Items.Add(BGLVI)
            BGLVI.Selected = True
        End If

    End Sub
    Private Sub CommandPanel1_Edit() Handles CommandPanel1.Edit
        Dim Idx As Integer = Me.ListViewRechtecke.SelectedItems(0).Index
        Dim BG As BeschriftungsRechteck = m_Rechtecke(Idx)
        Dim Text As String = InputBox("Bitte genderten Text angeben", "PhotoCollector", BG.Text)
        Text = Text.Trim
        If Text <> "" Then
            If Text <> BG.Text Then
                BG.Text = Text
            End If
        End If
    End Sub
    Private Sub CommandPanel1_Delete() Handles CommandPanel1.Delete
        If MessageBox.Show("Ausgewhlte Beschriftung wirklich lschen?", "PhotoCollector", MessageBoxButtons.YesNo, MessageBoxIcon.Question) = DialogResult.No Then Exit Sub
        Dim Idx As Integer = ListViewRechtecke.SelectedItems(0).Index
        m_Rechtecke.RemoveAt(Idx)
        Me.ListViewRechtecke.Items.RemoveAt(Idx)
    End Sub

    Private Sub CommandPanel1_MoveDown() Handles CommandPanel1.MoveDown
        m_Initialisierung = True

        Dim BGLVI As BeschriftungsRechteckListViewItem = ListViewRechtecke.SelectedItems(0)
        Dim Idx As Integer = BGLVI.Index

        m_Rechtecke.RemoveAt(Idx)
        ListViewRechtecke.Items.Remove(BGLVI)
        m_Rechtecke.Insert(Idx + 1, BGLVI.BeschriftungsRechteck)
        ListViewRechtecke.Items.Insert(Idx + 1, BGLVI)
        BGLVI.Selected = True

        m_Initialisierung = False
        CorrectCommandPanel()
    End Sub

    Private Sub CommandPanel1_MoveUp() Handles CommandPanel1.MoveUp
        m_Initialisierung = True
        Dim BGLVI As BeschriftungsRechteckListViewItem = ListViewRechtecke.SelectedItems(0)
        Dim Idx As Integer = BGLVI.Index

        m_Rechtecke.RemoveAt(Idx)
        ListViewRechtecke.Items.Remove(BGLVI)
        m_Rechtecke.Insert(Idx - 1, BGLVI.BeschriftungsRechteck)
        ListViewRechtecke.Items.Insert(Idx - 1, BGLVI)
        BGLVI.Selected = True

        m_Initialisierung = False
        CorrectCommandPanel()
    End Sub

    Private Sub BeschriftungsRechteckEditor_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        If Me.ListViewRechtecke IsNot Nothing Then
            If Me.ListViewRechtecke.Columns IsNot Nothing Then
                ListViewRechtecke.Columns(0).Width = -2
            End If
        End If
    End Sub


    Private Sub m_Rechtecke_SelectedRechteckChanged(ByVal Sender As Object) Handles m_Rechtecke.SelectedRechteckChanged
        If Sender IsNot Me Then

            If m_Rechtecke.Count > Me.ListViewRechtecke.Items.Count Then
                For I As Integer = Me.ListViewRechtecke.Items.Count To m_Rechtecke.Count - 1
                    Me.ListViewRechtecke.Items.Add(New BeschriftungsRechteckListViewItem(m_Rechtecke(I)))
                Next
            End If

            For Each Itm As BeschriftungsRechteckListViewItem In Me.ListViewRechtecke.Items
                If Itm.BeschriftungsRechteck Is m_Rechtecke.SelectedRE Then
                    Itm.Selected = True
                    Exit For
                End If
            Next

            CorrectCommandPanel()
        End If
    End Sub
End Class
