Public Class BildGruppenChecker
    Private m_BildGruppen As List(Of BildGruppe)
    Private m_Bild As Bild
    Private m_Initialisierung As Boolean = False

    Public Sub Init(ByVal BildGruppen As List(Of BildGruppe))
        If m_BildGruppen IsNot BildGruppen Then
            Bild = Nothing
            m_BildGruppen = BildGruppen
            fillBildGruppen()
        End If
    End Sub
    'Public Sub SetValues(ByVal BildGruppen As List(Of BildGruppe), ByVal Bld As Bild)
    '    If m_BildGruppen IsNot BildGruppen Then
    '        m_BildGruppen = BildGruppen
    '        fillBildGruppen()
    '    End If
    '    m_Bild = Bld
    '    InitBild()
    'End Sub
    Private Sub fillBildGruppen()
        m_Initialisierung = True
        Me.CheckedListBox1.Items.Clear()
        For Each BG As BildGruppe In m_BildGruppen
            Me.CheckedListBox1.Items.Add(BG.ToString)
        Next
        m_Initialisierung = False
    End Sub
    WriteOnly Property Bild() As Bild
        Set(ByVal value As Bild)
            If m_Bild IsNot value Then
                m_Bild = value
                InitBild()
            End If
        End Set
    End Property

    Private Sub InitBild()
        m_Initialisierung = True

        If m_Bild Is Nothing Then
            If Me.CheckedListBox1.Items.Count > 0 Then
                For I As Integer = 0 To Me.CheckedListBox1.Items.Count - 1
                    Me.CheckedListBox1.SetItemChecked(I, False)
                Next
            End If
            Me.CheckedListBox1.Enabled = False
            Me.CommandPanel1.Enabled = False
        Else
            If Me.CheckedListBox1.Items.Count > 0 Then
                For I As Integer = 0 To Me.CheckedListBox1.Items.Count - 1
                    Me.CheckedListBox1.SetItemChecked(I, m_BildGruppen(I).Contains(m_Bild))
                Next
            End If
            Me.CheckedListBox1.Enabled = True
            Me.CommandPanel1.Enabled = True
        End If

        m_Initialisierung = False
    End Sub

    Private Sub CheckedListBox1_ItemCheck(ByVal sender As Object, ByVal e As System.Windows.Forms.ItemCheckEventArgs) Handles CheckedListBox1.ItemCheck
        If m_Initialisierung Then Exit Sub
        Dim BG As BildGruppe = m_BildGruppen(e.Index)
        If e.NewValue = CheckState.Checked Then
            If Not BG.Contains(m_Bild) Then BG.Add(m_Bild)
        Else
            If BG.Contains(m_Bild) Then BG.Remove(m_Bild)
        End If
    End Sub

    Private Sub CommandPanel1_AddNew() Handles CommandPanel1.AddNew
        Dim Text As String = InputBox("Bitte neuen Begriff angeben", "PhotoCollector", "")
        Text = Text.Trim
        If Text <> "" Then
            Dim BG As New BildGruppe(Text)
            m_BildGruppen.Add(BG)
            Me.CheckedListBox1.Items.Add(BG.ToString)
            Me.CheckedListBox1.SetItemChecked(Me.CheckedListBox1.Items.Count - 1, True)
            Me.CheckedListBox1.SelectedIndex = Me.CheckedListBox1.Items.Count - 1
        End If
    End Sub

    Private Sub CheckedListBox1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckedListBox1.SelectedIndexChanged
        If CheckedListBox1.SelectedIndex = -1 Then
            Me.CommandPanel1.ButtonDelete.Enabled = False
            Me.CommandPanel1.ButtonEdit.Enabled = False
            Me.CommandPanel1.ButtonMoveDown.Enabled = False
            Me.CommandPanel1.ButtonMoveUp.Enabled = False
        Else
            Me.CommandPanel1.ButtonDelete.Enabled = True
            Me.CommandPanel1.ButtonEdit.Enabled = True
            If CheckedListBox1.SelectedIndex = 0 Then
                Me.CommandPanel1.ButtonMoveUp.Enabled = False
            Else
                Me.CommandPanel1.ButtonMoveUp.Enabled = True
            End If
            If CheckedListBox1.SelectedIndex = CheckedListBox1.Items.Count - 1 Then
                Me.CommandPanel1.ButtonMoveDown.Enabled = False
            Else
                Me.CommandPanel1.ButtonMoveDown.Enabled = True
            End If
        End If
    End Sub

    Private Sub BildGruppenChecker_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Me.CommandPanel1.ButtonMoveLeft.Visible = False
        Me.CommandPanel1.ButtonMoveRight.Visible = False
        Me.CommandPanel1.ButtonMoveDown.Left = 2
        Me.CommandPanel1.ButtonMoveUp.Left = 28
    End Sub

    Private Sub CommandPanel1_Delete() Handles CommandPanel1.Delete
        If MessageBox.Show("Ausgewhlten Begriff wirklich lschen?", "Photocollector", MessageBoxButtons.YesNo, MessageBoxIcon.Question) = DialogResult.No Then Exit Sub
        Dim Idx As Integer = Me.CheckedListBox1.SelectedIndex
        m_BildGruppen.RemoveAt(Idx)
        Me.CheckedListBox1.Items.RemoveAt(Idx)
    End Sub

    Private Sub CommandPanel1_Edit() Handles CommandPanel1.Edit
        Dim Idx As Integer = Me.CheckedListBox1.SelectedIndex
        Dim BG As BildGruppe = m_BildGruppen(Idx)
        Dim Text As String = InputBox("Bitte genderten Begriff angeben", "PhotoCollector", BG.Word)
        Text = Text.Trim
        If Text <> "" Then
            If Text <> BG.Word Then
                BG.Word = Text
                Me.CheckedListBox1.Items.RemoveAt(Idx)
                Me.CheckedListBox1.Items.Insert(Idx, BG.ToString)
                m_Initialisierung = True
                Me.CheckedListBox1.SetItemChecked(Idx, BG.Contains(m_Bild))
                m_Initialisierung = False
                CheckedListBox1.SelectedIndex = Idx
            End If
        End If
    End Sub

    Private Sub CommandPanel1_MoveDown() Handles CommandPanel1.MoveDown
        Dim Idx As Integer = Me.CheckedListBox1.SelectedIndex
        Dim BG As BildGruppe = m_BildGruppen(Idx)
        m_BildGruppen.RemoveAt(Idx)
        Me.CheckedListBox1.Items.RemoveAt(Idx)
        m_BildGruppen.Insert(Idx + 1, BG)
        Me.CheckedListBox1.Items.Insert(Idx + 1, BG.ToString)
        m_Initialisierung = True
        Me.CheckedListBox1.SetItemChecked(Idx + 1, BG.Contains(m_Bild))
        m_Initialisierung = False
        CheckedListBox1.SelectedIndex = Idx + 1
    End Sub

    Private Sub CommandPanel1_MoveUp() Handles CommandPanel1.MoveUp
        Dim Idx As Integer = Me.CheckedListBox1.SelectedIndex
        Dim BG As BildGruppe = m_BildGruppen(Idx)
        m_BildGruppen.RemoveAt(Idx)
        Me.CheckedListBox1.Items.RemoveAt(Idx)
        m_BildGruppen.Insert(Idx - 1, BG)
        Me.CheckedListBox1.Items.Insert(Idx - 1, BG.ToString)
        m_Initialisierung = True
        Me.CheckedListBox1.SetItemChecked(Idx - 1, BG.Contains(m_Bild))
        m_Initialisierung = False
        CheckedListBox1.SelectedIndex = Idx - 1
    End Sub
End Class
