Public Class BildGruppenSelector
    Public Event SelectedBildgruppe_Changed(ByVal SelectedBildgruppe As BildGruppe)
    Private m_SelectedBildGruppe As BildGruppe
    Private m_BildGruppen As List(Of BildGruppe)
    Private m_Initialisierung As Boolean = False
    Public Sub Init(ByVal BildGruppen As List(Of BildGruppe))
        m_BildGruppen = BildGruppen
        For Each BG As BildGruppe In m_BildGruppen
            Me.ListViewBildgruppen.Items.Add(New BildGruppenListViewItem(BG))
        Next
        If Me.ListViewBildgruppen.Items.Count > 0 Then
            Me.ListViewBildgruppen.Items(0).Selected = True
        End If
    End Sub
    Private Sub ListViewBildgruppen_ItemCheck(ByVal sender As Object, ByVal e As System.Windows.Forms.ItemCheckEventArgs) Handles ListViewBildgruppen.ItemCheck
        If m_Initialisierung Then Exit Sub
        Dim BG As BildGruppe = m_BildGruppen(e.Index)
        If e.NewValue = CheckState.Checked Then
            If Not BG.IsToPublish Then BG.IsToPublish = True
        Else
            If BG.IsToPublish Then BG.IsToPublish = False
        End If
    End Sub
    Private Sub SetSelectedBildgruppe(ByVal BG As BildGruppe)
        If m_Initialisierung Then Exit Sub

        Dim Changed As Boolean = False
        If m_SelectedBildGruppe IsNot BG Then
            m_SelectedBildGruppe = BG
            Changed = True
        End If

        If m_SelectedBildGruppe Is Nothing Then
            Me.CommandPanel1.ButtonDelete.Enabled = False
            Me.CommandPanel1.ButtonEdit.Enabled = False
            Me.CommandPanel1.ButtonMoveDown.Enabled = False
            Me.CommandPanel1.ButtonMoveUp.Enabled = False
        Else
            Me.CommandPanel1.ButtonDelete.Enabled = True
            Me.CommandPanel1.ButtonEdit.Enabled = True
            If ListViewBildgruppen.SelectedItems(0).Index = 0 Then
                Me.CommandPanel1.ButtonMoveUp.Enabled = False
            Else
                Me.CommandPanel1.ButtonMoveUp.Enabled = True
            End If
            If ListViewBildgruppen.SelectedItems(0).Index = ListViewBildgruppen.Items.Count - 1 Then
                Me.CommandPanel1.ButtonMoveDown.Enabled = False
            Else
                Me.CommandPanel1.ButtonMoveDown.Enabled = True
            End If
        End If

        If Changed Then
            RaiseEvent SelectedBildgruppe_Changed(BG)
        End If

    End Sub

    Private Sub ListViewBildgruppen_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ListViewBildgruppen.SelectedIndexChanged
        If Me.ListViewBildgruppen.SelectedItems.Count > 0 Then
            Dim BGLVI As BildGruppenListViewItem = ListViewBildgruppen.SelectedItems(0)
            SetSelectedBildgruppe(BGLVI.BildGruppe)
        Else
            SetSelectedBildgruppe(Nothing)
        End If
    End Sub


    Private Sub BildGruppenSelector_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Me.CommandPanel1.ButtonMoveLeft.Visible = False
        Me.CommandPanel1.ButtonMoveRight.Visible = False
        Me.CommandPanel1.ButtonMoveDown.Left = 2
        Me.CommandPanel1.ButtonMoveUp.Left = 28
        Me.CommandPanel1.ButtonEdit.Visible = False
    End Sub

    Private Sub CommandPanel1_AddNew() Handles CommandPanel1.AddNew
        Dim Text As String = InputBox("Bitte neue Gruppenbezeichnung angeben", "PhotoCollector", "")
        Text = Text.Trim
        If Text <> "" Then
            Dim BG As New BildGruppe(Text)
            BG.IsToPublish = True
            m_BildGruppen.Add(BG)
            Dim BGLVI As New BildGruppenListViewItem(BG)
            Me.ListViewBildgruppen.Items.Add(BGLVI)
            BGLVI.Selected = True
        End If
    End Sub

    Private Sub CommandPanel1_Delete() Handles CommandPanel1.Delete
        If MessageBox.Show("Ausgewhlte Gruppe wirklich lschen?", "PhotoCollector", MessageBoxButtons.YesNo, MessageBoxIcon.Question) = DialogResult.No Then Exit Sub
        Dim Idx As Integer = ListViewBildgruppen.SelectedItems(0).Index
        m_BildGruppen.RemoveAt(Idx)
        Me.ListViewBildgruppen.Items.RemoveAt(Idx)
    End Sub

    Private Sub CommandPanel1_MoveDown() Handles CommandPanel1.MoveDown
        m_Initialisierung = True
        Dim BGLVI As BildGruppenListViewItem = ListViewBildgruppen.SelectedItems(0)
        Dim Idx As Integer = BGLVI.Index

        m_BildGruppen.RemoveAt(Idx)
        ListViewBildgruppen.Items.Remove(BGLVI)
        m_BildGruppen.Insert(Idx + 1, BGLVI.BildGruppe)
        ListViewBildgruppen.Items.Insert(Idx + 1, BGLVI)
        BGLVI.Selected = True

        m_Initialisierung = False
        SetSelectedBildgruppe(BGLVI.BildGruppe)
    End Sub

    Private Sub CommandPanel1_MoveUp() Handles CommandPanel1.MoveUp
        m_Initialisierung = True
        Dim BGLVI As BildGruppenListViewItem = ListViewBildgruppen.SelectedItems(0)
        Dim Idx As Integer = BGLVI.Index

        m_BildGruppen.RemoveAt(Idx)
        ListViewBildgruppen.Items.Remove(BGLVI)
        m_BildGruppen.Insert(Idx - 1, BGLVI.BildGruppe)
        ListViewBildgruppen.Items.Insert(Idx - 1, BGLVI)
        BGLVI.Selected = True

        m_Initialisierung = False
        SetSelectedBildgruppe(BGLVI.BildGruppe)
    End Sub

    Private Sub BildGruppenSelector_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        If Me.ListViewBildgruppen IsNot Nothing Then
            If Me.ListViewBildgruppen.Columns IsNot Nothing Then
                ListViewBildgruppen.Columns(1).Width = -2
            End If
        End If
    End Sub
End Class
