Public Class DatumsAngabeEditor
    Private m_Liste As DatumsangabeListe
    'Private m_Bild As Bild
    Private m_Bilder As List(Of Bild)
    Private m_Initialisierung As Boolean = False

    Private m_ExifZeitEditor As DatumEditorExifZeit
    Private m_ExaktEditor As DatumEditorExakt
    Private m_JahrEditor As DatumEditorJahr
    Private m_JahreszeitEditor As DatumEditorJahreszeit
    Private m_JahrzehntEditor As DatumEditorJahrzehnt
    Private m_MonatEditor As DatumEditorMonat

    Private m_ActiveEditControl As Control

    Public Sub Init(ByVal Liste As DatumsangabeListe)
        m_Liste = Liste
        m_ExifZeitEditor = New DatumEditorExifZeit(m_Liste.LastExifZeitAngabe)
        m_ExaktEditor = New DatumEditorExakt(m_Liste.LastExaktAngabe)
        m_JahrEditor = New DatumEditorJahr(m_Liste.LastJahrAngabe)
        m_JahreszeitEditor = New DatumEditorJahreszeit(m_Liste.LastJahreszeitAngabe)
        m_JahrzehntEditor = New DatumEditorJahrzehnt(m_Liste.LastJahrzehntAngabe)
        m_MonatEditor = New DatumEditorMonat(m_Liste.LastMonatsAngabe)

        m_ExifZeitEditor.Dock = DockStyle.Fill
        m_ExaktEditor.Dock = DockStyle.Fill
        m_JahrEditor.Dock = DockStyle.Fill
        m_JahreszeitEditor.Dock = DockStyle.Fill
        m_JahrzehntEditor.Dock = DockStyle.Fill
        m_MonatEditor.Dock = DockStyle.Fill

        m_ExifZeitEditor.Visible = False
        m_ExaktEditor.Visible = False
        m_JahrEditor.Visible = False
        m_JahreszeitEditor.Visible = False
        m_JahrzehntEditor.Visible = False
        m_MonatEditor.Visible = False

        Me.PanelEditor.Controls.Add(m_ExifZeitEditor)
        Me.PanelEditor.Controls.Add(m_ExaktEditor)
        Me.PanelEditor.Controls.Add(m_JahrEditor)
        Me.PanelEditor.Controls.Add(m_JahreszeitEditor)
        Me.PanelEditor.Controls.Add(m_JahrzehntEditor)
        Me.PanelEditor.Controls.Add(m_MonatEditor)
    End Sub
    WriteOnly Property Bilder() As List(Of Bild)
        Set(ByVal value As List(Of Bild))
            m_Bilder = value
            InitBilder()
        End Set
    End Property
    'WriteOnly Property Bild() As Bild
    '    Set(ByVal value As Bild)
    '        m_Bild = value
    '        InitBild()
    '    End Set
    'End Property

    Private Sub SetActiveEditControl(ByVal NewCtl As IDatumEditor, ByVal newValue As IDatumsAngabe)
        If NewCtl Is Nothing Then
            If m_ActiveEditControl IsNot Nothing Then
                m_ActiveEditControl.Visible = False
                m_ActiveEditControl = Nothing
            End If
        Else
            If NewCtl IsNot m_ActiveEditControl Then
                If m_ActiveEditControl IsNot Nothing Then
                    m_ActiveEditControl.Visible = False
                    m_ActiveEditControl = Nothing
                End If
                m_ActiveEditControl = NewCtl
                m_ActiveEditControl.Visible = True
            End If
            NewCtl.SetValue(newValue)
        End If
    End Sub

    Private Sub ChangeActiveEditControl(ByVal NewCtl As IDatumEditor)
        If NewCtl Is Nothing Then
            If m_ActiveEditControl IsNot Nothing Then
                m_ActiveEditControl.Visible = False
                m_ActiveEditControl = Nothing
            End If
        Else
            If NewCtl IsNot m_ActiveEditControl Then
                If m_ActiveEditControl IsNot Nothing Then
                    m_ActiveEditControl.Visible = False
                    m_ActiveEditControl = Nothing
                End If
                m_ActiveEditControl = NewCtl
                m_ActiveEditControl.Visible = True
            End If
        End If
    End Sub

    Private Sub InitBilder()


        m_Initialisierung = True

        If m_Bilder.Count = 0 Then
            Me.ToolStripComboBox1.SelectedIndex = 0
            Me.Enabled = False
        ElseIf m_Bilder.Count = 1 Then
            Dim Bld As Bild = m_Bilder(0)
            Me.Enabled = True

            Select Case Bld.Datumsangabe.Typ
                Case DatumsangabeTypen.ExifZeit
                    Me.ToolStripComboBox1.SelectedIndex = 6
                    SetActiveEditControl(m_ExifZeitEditor, Bld.Datumsangabe)
                Case DatumsangabeTypen.Exakt
                    Me.ToolStripComboBox1.SelectedIndex = 1
                    SetActiveEditControl(m_ExaktEditor, Bld.Datumsangabe)
                Case DatumsangabeTypen.Jahr
                    Me.ToolStripComboBox1.SelectedIndex = 4
                    SetActiveEditControl(m_JahrEditor, Bld.Datumsangabe)
                Case DatumsangabeTypen.Jahreszeit
                    Me.ToolStripComboBox1.SelectedIndex = 3
                    SetActiveEditControl(m_JahreszeitEditor, Bld.Datumsangabe)
                Case DatumsangabeTypen.Jahrzehnt
                    Me.ToolStripComboBox1.SelectedIndex = 5
                    SetActiveEditControl(m_JahrzehntEditor, Bld.Datumsangabe)
                Case DatumsangabeTypen.Monat
                    Me.ToolStripComboBox1.SelectedIndex = 2
                    SetActiveEditControl(m_MonatEditor, Bld.Datumsangabe)
                Case DatumsangabeTypen.Unknown
                    Me.ToolStripComboBox1.SelectedIndex = 0
                    SetActiveEditControl(Nothing, Bld.Datumsangabe)
            End Select

        Else
            'Bilder.count > 1

            Dim DatumGleich As Boolean = True
            For I As Integer = 1 To m_Bilder.Count - 1
                If m_Bilder(I).Datumsangabe IsNot m_Bilder(0).Datumsangabe Then
                    DatumGleich = False
                End If
            Next
            If DatumGleich Then
                Dim Bld As Bild = m_Bilder(0)

                Select Case Bld.Datumsangabe.Typ
                    Case DatumsangabeTypen.ExifZeit
                        Me.ToolStripComboBox1.SelectedIndex = 6
                        SetActiveEditControl(m_ExifZeitEditor, Bld.Datumsangabe)
                    Case DatumsangabeTypen.Exakt
                        Me.ToolStripComboBox1.SelectedIndex = 1
                        SetActiveEditControl(m_ExaktEditor, Bld.Datumsangabe)
                    Case DatumsangabeTypen.Jahr
                        Me.ToolStripComboBox1.SelectedIndex = 4
                        SetActiveEditControl(m_JahrEditor, Bld.Datumsangabe)
                    Case DatumsangabeTypen.Jahreszeit
                        Me.ToolStripComboBox1.SelectedIndex = 3
                        SetActiveEditControl(m_JahreszeitEditor, Bld.Datumsangabe)
                    Case DatumsangabeTypen.Jahrzehnt
                        Me.ToolStripComboBox1.SelectedIndex = 5
                        SetActiveEditControl(m_JahrzehntEditor, Bld.Datumsangabe)
                    Case DatumsangabeTypen.Monat
                        Me.ToolStripComboBox1.SelectedIndex = 2
                        SetActiveEditControl(m_MonatEditor, Bld.Datumsangabe)
                    Case DatumsangabeTypen.Unknown
                        Me.ToolStripComboBox1.SelectedIndex = 0
                        SetActiveEditControl(Nothing, Bld.Datumsangabe)
                End Select
            Else
                Me.ToolStripComboBox1.SelectedIndex = -1
                SetActiveEditControl(Nothing, Nothing)

            End If
            Me.Enabled = True
        End If


        m_Initialisierung = False

    End Sub


    Private Sub ToolStripComboBox1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripComboBox1.SelectedIndexChanged
        If m_Initialisierung Then Exit Sub


        Select Case ToolStripComboBox1.SelectedIndex
            Case 0 'unbekannt
                ChangeActiveEditControl(Nothing)
            Case 1 'Exakt
                ChangeActiveEditControl(m_ExaktEditor)
            Case 2 'Monat
                ChangeActiveEditControl(m_MonatEditor)
            Case 3 'Jahreszeit
                ChangeActiveEditControl(m_JahreszeitEditor)
            Case 4 'Jahr
                ChangeActiveEditControl(m_JahrEditor)
            Case 5 'Jahrzehnt
                ChangeActiveEditControl(m_JahrzehntEditor)
            Case 6 'ExifZeit
                ChangeActiveEditControl(m_ExifZeitEditor)
        End Select

    End Sub

    Private Sub DatumsangabeEditor_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles Me.Validating

        For Each Bld As Bild In m_Bilder
            If ToolStripComboBox1.SelectedIndex = 0 Then
                m_Liste.SetDatumForBild(UnbekanntDatumsAngabe, Bld)
            Else
                Dim Editor As IDatumEditor = m_ActiveEditControl
                If Editor.HasValidValue Then
                    m_Liste.SetDatumForBild(Editor.CreateValue, Bld)
                    'Else
                    '    m_Liste.SetDatumForBild(UnbekanntDatumsAngabe, Bld)
                End If
            End If
        Next
       
    End Sub

    Public Sub New()

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fgen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.
        Me.Enabled = False
    End Sub
End Class
