Public Class BeschriftungsRechteckSelector
    Private m_MoveMode As BeschriftungsRechteckHitTestResults = BeschriftungsRechteckHitTestResults.None
    Private m_HittedBeschriftungsRechteck As BeschriftungsRechteck = Nothing
    Private m_StartPoint As Point = Point.Empty
    Private m_StartRechteckRect As Rectangle = Rectangle.Empty
    Private m_BZR As BildZeichenRechteck
    Public Sub New(ByVal HittedBeschriftungsRechteck As BeschriftungsRechteck, ByVal MoveMode As BeschriftungsRechteckHitTestResults, ByVal StartPoint As Point, ByVal BZR As BildZeichenRechteck)
        m_HittedBeschriftungsRechteck = HittedBeschriftungsRechteck
        m_MoveMode = MoveMode
        m_StartRechteckRect = New Rectangle(m_HittedBeschriftungsRechteck.Left, m_HittedBeschriftungsRechteck.Top, m_HittedBeschriftungsRechteck.Width, m_HittedBeschriftungsRechteck.Height)
        m_StartPoint = StartPoint
        m_BZR = BZR
    End Sub
    Public Sub Update(ByVal newPoint As Point)
        Dim MovedX As Integer = newPoint.X - m_StartPoint.X
        Dim MovedY As Integer = newPoint.Y - m_StartPoint.Y
        Dim RealMove As PointF = m_BZR.UnZoomPoint(New PointF(CSng(MovedX), CSng(MovedY)))

        Dim OrigRect As New Rectangle(m_StartRechteckRect.X, m_StartRechteckRect.Y, m_StartRechteckRect.Width, m_StartRechteckRect.Height)

        Select Case m_MoveMode
            Case BeschriftungsRechteckHitTestResults.Left
                OrigRect.X += RealMove.X
                OrigRect.Width -= RealMove.X
            Case BeschriftungsRechteckHitTestResults.Top
                OrigRect.Y += RealMove.Y
                OrigRect.Height -= RealMove.Y
            Case BeschriftungsRechteckHitTestResults.Bottom
                OrigRect.Height += RealMove.Y
            Case BeschriftungsRechteckHitTestResults.Right
                OrigRect.Width += RealMove.X
            Case BeschriftungsRechteckHitTestResults.MoveArea
                OrigRect.X += RealMove.X
                OrigRect.Y += RealMove.Y
        End Select

        If OrigRect.X < 0 Then
            Dim Diff As Integer = OrigRect.X
            OrigRect.X = 0
            OrigRect.Width += Diff
        End If

        If OrigRect.Y < 0 Then
            Dim Diff As Integer = OrigRect.Y
            OrigRect.Y = 0
            OrigRect.Height += Diff
        End If
        If OrigRect.X + OrigRect.Width > m_BZR.OriginalBildGroesse.Width Then
            OrigRect.Width = m_BZR.OriginalBildGroesse.Width - OrigRect.X
        End If
        If OrigRect.Y + OrigRect.Height > m_BZR.OriginalBildGroesse.Height Then
            OrigRect.Height = m_BZR.OriginalBildGroesse.Height - OrigRect.Y
        End If
        If OrigRect.Width < 5 Then
            OrigRect.Width = 5
        End If
        If OrigRect.Height < 5 Then
            OrigRect.Height = 5
        End If

        m_HittedBeschriftungsRechteck.Rect = OrigRect

    End Sub
End Class
