Imports System.Reflection
Public Class ZoomBeschriftungsControl
    Implements IEditColorsControl
    Private m_BZR As BildZeichenRechteck

    Private m_Image As Image
    Private m_BaseImage As Image

    Private m_Zoom As Single = 100.0F
    Public Event ZoomChanged()
    Private m_Selector As Selector
    Private m_Mode As PictureControlModes = PictureControlModes.SelectMode

    Private m_PlusCursor As Cursor
    Private m_MinusCursor As Cursor
    Private m_HandCursor As Cursor
    Private m_PencilCursor As Cursor

    Private WithEvents m_BildLader As New AsynchronBildLader

    Private m_EditColorValues As EditColorValues

    Property Mode() As PictureControlModes
        Get
            Return m_Mode
        End Get
        Set(ByVal value As PictureControlModes)
            m_Mode = value
        End Set
    End Property

    Property Zoom() As Single
        Get
            Return m_Zoom
        End Get
        Set(ByVal value As Single)
            If m_BZR IsNot Nothing Then
                Me.m_BZR.SetZoom(value)
                ScrollBarsUndBild_Neu_Anzeigen()
            End If

        End Set
    End Property

    Private m_Bild As Bild
    Property Bild() As Bild
        Get
            Return m_Bild
        End Get
        Set(ByVal value As Bild)
            m_Bild = value
            If m_Bild Is Nothing Then
                m_BildLader.Bild_Laden("")
            Else
                m_BildLader.Bild_Laden(m_Bild.Pfad)
            End If

        End Set
    End Property


    Delegate Sub BildLader()
    Private Sub BildLaden()
        m_Image = m_BildLader.Image
        If m_Image Is Nothing Then
            m_BaseImage = Nothing
        Else
            m_BaseImage = New Bitmap(m_Image)
        End If

        Me.VScrollBar1.Visible = False
        Me.HScrollBar1.Visible = False
        Me.ZoomBeschriftungsPainter1.Size = Me.Size
        If m_Image Is Nothing Then
            m_BZR = Nothing
            SetZoom(100.0F)
            Me.ZoomBeschriftungsPainter1.PaintImage(Nothing, PointF.Empty, SizeF.Empty, Nothing, 0.0R)
            m_EditColorValues = Nothing
        Else
            m_BZR = New BildZeichenRechteck(Me.Size, m_Image.Size)
            SetZoom(m_BZR.GetZoom)
            Me.ZoomBeschriftungsPainter1.PaintImage(m_Image, m_BZR.ZoomedBildPosition, m_BZR.ZoomedBildSize, m_Bild.Beschriftungen, m_BZR.ScaleFactor)
            m_EditColorValues = New EditColorValues
        End If
    End Sub
    Private Sub m_BildLader_Bild_Geaendert() Handles m_BildLader.Bild_Geaendert
        If InvokeRequired Then
            Me.BeginInvoke(New BildLader(AddressOf BildLaden))
            Exit Sub
        End If
        BildLaden()
    End Sub


    Private Sub SetZoom(ByVal NewValue As Single)
        If m_Zoom <> NewValue Then
            m_Zoom = NewValue
            RaiseEvent ZoomChanged()
        End If
    End Sub

    Private Sub ZoomControl_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        ScrollBarsUndBild_Neu_Anzeigen()
    End Sub

    Private Sub ScrollBarsUndBild_Neu_Anzeigen()
        If m_Image IsNot Nothing Then

            Me.SuspendLayout()

            m_BZR.ControlSize = Me.Size

            Dim HScrollSichtbar As Boolean = False
            Dim VScrollSichtbar As Boolean = False

            Dim PainterBreite As Integer = Me.Size.Width
            Dim PainterHoehe As Integer = Me.Size.Height

            If m_BZR.ZoomedBildSize.Width > Me.Width Then
                'Horizontale Scrollbar muss sichtbar sein
                PainterHoehe -= 17
                HScrollSichtbar = True
            End If
            If m_BZR.ZoomedBildSize.Height > Me.Height Then
                'Vertikale Scrollbar muss sichtbar sein
                PainterBreite -= 17
                VScrollSichtbar = True
            End If

            If HScrollSichtbar OrElse VScrollSichtbar Then
                m_BZR.ControlSize = New Size(PainterBreite, PainterHoehe)
                Me.ZoomBeschriftungsPainter1.Size = New Size(PainterBreite, PainterHoehe)
                SuspendScrolling()

                If HScrollSichtbar Then
                    Me.HScrollBar1.Location = New Point(0, Me.Height - 17)
                    If VScrollSichtbar Then
                        Me.HScrollBar1.Size = New Size(Me.Width - 17, 17)
                    Else
                        Me.HScrollBar1.Size = New Size(Me.Width, 17)
                    End If
                    Me.HScrollBar1.Maximum = Math.Ceiling(m_BZR.ZoomedBildSize.Width)
                    Me.HScrollBar1.Value = m_BZR.ZoomedBildPosition.X * -1
                    Me.HScrollBar1.LargeChange = PainterBreite
                    Me.HScrollBar1.Visible = True
                Else
                    Me.HScrollBar1.Visible = False
                End If

                If VScrollSichtbar Then
                    Me.VScrollBar1.Location = New Point(Me.Width - 17, 0)
                    If HScrollSichtbar Then
                        Me.VScrollBar1.Size = New Size(17, Me.Height - 17)
                    Else
                        Me.VScrollBar1.Size = New Size(17, Me.Height)
                    End If
                    Me.VScrollBar1.AutoSize = False
                    Me.VScrollBar1.Maximum = Math.Ceiling(m_BZR.ZoomedBildSize.Height)
                    Me.VScrollBar1.Value = m_BZR.ZoomedBildPosition.Y * -1
                    Me.VScrollBar1.LargeChange = PainterHoehe
                    Me.VScrollBar1.Visible = True
                Else
                    Me.VScrollBar1.Visible = False
                End If

                ResumeScrolling()
            Else
                Me.ZoomBeschriftungsPainter1.Size = Me.Size
                Me.VScrollBar1.Visible = False
                Me.HScrollBar1.Visible = False
            End If

            Me.ZoomBeschriftungsPainter1.PaintImage(m_Image, m_BZR.ZoomedBildPosition, m_BZR.ZoomedBildSize, m_Bild.Beschriftungen, m_BZR.ScaleFactor)


            Me.ResumeLayout()
        Else
            Me.ZoomBeschriftungsPainter1.Size = Me.Size
            Me.VScrollBar1.Visible = False
            Me.HScrollBar1.Visible = False

            Dim Beschr As BeschriftungsRechteckListe = Nothing

            If m_Bild IsNot Nothing Then
                Beschr = m_Bild.Beschriftungen
            End If

            Dim XScaleFactor As Double = 0.0R
            If m_BZR IsNot Nothing Then
                XScaleFactor = m_BZR.ScaleFactor
            End If


            Me.ZoomBeschriftungsPainter1.PaintImage(m_Image, New PointF(0.0F, 0.0F), New SizeF(Me.Width, Me.Height), Beschr, XScaleFactor)

        End If
    End Sub


    Private Sub ScrollVertical(ByVal sender As Object, ByVal e As System.Windows.Forms.ScrollEventArgs)
        Dim Extreme As ExtremeValues = ExtremeValues.Middle
        If e.NewValue <= 0 Then
            Extreme = ExtremeValues.LeftMost
        ElseIf e.NewValue >= Me.VScrollBar1.Maximum - Me.VScrollBar1.LargeChange Then
            Extreme = ExtremeValues.RightMost
        End If

        m_BZR.SetNewTopPosition(e.NewValue * -1, Extreme, True)

        Me.ZoomBeschriftungsPainter1.PaintImage(m_Image, m_BZR.ZoomedBildPosition, m_BZR.ZoomedBildSize, m_Bild.Beschriftungen, m_BZR.ScaleFactor)
    End Sub
    Private Sub ScrollHorizontal(ByVal sender As Object, ByVal e As System.Windows.Forms.ScrollEventArgs)
        Dim Extreme As ExtremeValues = ExtremeValues.Middle
        If e.NewValue <= 0 Then
            Extreme = ExtremeValues.LeftMost
        ElseIf e.NewValue >= Me.HScrollBar1.Maximum - Me.HScrollBar1.LargeChange Then
            Extreme = ExtremeValues.RightMost
        End If

        m_BZR.SetNewLeftPosition(e.NewValue * -1, Extreme, True)

        Me.ZoomBeschriftungsPainter1.PaintImage(m_Image, m_BZR.ZoomedBildPosition, m_BZR.ZoomedBildSize, m_Bild.Beschriftungen, m_BZR.ScaleFactor)
    End Sub
    Private ScrollActivated As Boolean = False
    Private Sub SuspendScrolling()
        If ScrollActivated Then
            RemoveHandler HScrollBar1.Scroll, AddressOf ScrollHorizontal
            RemoveHandler VScrollBar1.Scroll, AddressOf ScrollVertical
            ScrollActivated = False
        End If
    End Sub
    Private Sub ResumeScrolling()
        If Not ScrollActivated Then
            AddHandler HScrollBar1.Scroll, AddressOf ScrollHorizontal
            AddHandler VScrollBar1.Scroll, AddressOf ScrollVertical
            ScrollActivated = True
        End If
    End Sub
    Private m_BeschriftungsRechteckSelector As BeschriftungsRechteckSelector = Nothing
    Private Sub ZoomBeschriftungsPainter1_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles ZoomBeschriftungsPainter1.MouseDown
        If m_Image Is Nothing Then Exit Sub
        If e.Button = Windows.Forms.MouseButtons.Left AndAlso e.Clicks = 1 Then

            If AcHittedBeschriftungsRechteck IsNot Nothing Then
                m_BeschriftungsRechteckSelector = New BeschriftungsRechteckSelector(AcHittedBeschriftungsRechteck, AcMoveMode, e.Location, m_BZR)
                m_Bild.Beschriftungen.SetSelected(AcHittedBeschriftungsRechteck, Me)
                Exit Sub
            End If

            Dim p As New PointF(e.X, e.Y)

            If IsPointInImage(p) Then
                SetSelector(e.Location)
            Else
                SetSelector(Point.Empty)
            End If
        End If
    End Sub

    Private Sub SetSelector(ByVal Pt As Point)
        If Pt = Point.Empty Then
            m_Selector = Nothing
        Else
            If m_Selector Is Nothing Then
                m_Selector = New Selector(Pt)
            Else
                m_Selector.Update(Pt)
            End If
        End If

        If (m_Mode = PictureControlModes.ZoomIn) OrElse (m_Mode = PictureControlModes.DrawRectangle) Then
            Me.ZoomBeschriftungsPainter1.PaintSelector(m_Selector)
        End If
    End Sub

    Private Sub ZoomBeschriftungsPainter1_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles ZoomBeschriftungsPainter1.MouseLeave
        m_BeschriftungsRechteckSelector = Nothing
        Cursor = Cursors.Default
    End Sub
    Private Sub ZoomBeschriftungsPainter1_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles ZoomBeschriftungsPainter1.MouseMove
        If m_Image Is Nothing Then Exit Sub

        If m_BeschriftungsRechteckSelector IsNot Nothing Then
            m_BeschriftungsRechteckSelector.Update(e.Location)
            Exit Sub
        End If


        Dim p As New PointF(e.X, e.Y)
        SetCursor(p)

        If m_Selector IsNot Nothing Then
            SetSelector(New Point(e.X, e.Y))
            If (m_Mode = PictureControlModes.Hand) Or (m_Mode = PictureControlModes.SelectMode) Then
                PerformSelectorAction()
                m_Selector = New Selector(New Point(e.X, e.Y))
            End If
            'mehr wre jetzt nicht zu tun
        End If


    End Sub
    Private Sub ZoomBeschriftungsPainter1_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles ZoomBeschriftungsPainter1.MouseUp
        Dim p As New PointF(e.X, e.Y)

        m_BeschriftungsRechteckSelector = Nothing

        If e.Button = Windows.Forms.MouseButtons.Left Then
            If m_Selector IsNot Nothing Then
                'hier ggf. Zoom oder Bewegung durchfhren

                PerformSelectorAction()
                SetSelector(Nothing)
            End If
        End If


        SetCursor(p)
    End Sub
    Private Sub PerformSelectorAction()

        Select Case m_Mode
            Case PictureControlModes.ZoomOut
                m_BZR.ZoomOut()
                ScrollBarsUndBild_Neu_Anzeigen()
                m_Zoom = m_BZR.GetZoom
                RaiseEvent ZoomChanged()
            Case PictureControlModes.ZoomIn
                If m_Selector.Rectangle.Width < 5.0F AndAlso m_Selector.Rectangle.Height < 5.0F Then
                    'nur normales Zoomen
                    If IsPointInImage(m_Selector.StartPoint) Then
                        Dim MidPoint As New PointF(m_Selector.StartPoint.X - m_BZR.ZoomedBildPosition.X, m_Selector.StartPoint.Y - m_BZR.ZoomedBildPosition.Y)
                        m_BZR.ZoomIn(MidPoint)
                    Else
                        m_BZR.ZoomIn()
                    End If

                    ScrollBarsUndBild_Neu_Anzeigen()
                Else
                    'Zoom mit Auswahl-Rechteck
                    Dim Rect As New RectangleF(m_BZR.ZoomedBildPosition, m_BZR.ZoomedBildSize)
                    Dim ZoomRect As RectangleF = m_Selector.Rectangle

                    'Dieses Rechteck enthlt den zu zoomenden Ausschnitt, bezogen auf den Rand des Controls
                    Rect.Intersect(ZoomRect)

                    'Bentigt wird aber der Ausschnitt, bezogen auf den den Rand des Image 
                    Dim NewRect As New RectangleF(Rect.X - m_BZR.ZoomedBildPosition.X, Rect.Y - m_BZR.ZoomedBildPosition.Y, Rect.Width, Rect.Height)

                    m_BZR.ZoomInToRectangle(NewRect, Me.VScrollBar1.Visible, Me.HScrollBar1.Visible)
                    ScrollBarsUndBild_Neu_Anzeigen()
                End If
                m_Zoom = m_BZR.GetZoom
                RaiseEvent ZoomChanged()
            Case PictureControlModes.DrawRectangle
                If m_Selector.Rectangle.Width > 5.0F AndAlso m_Selector.Rectangle.Height > 5.0F Then
                    Dim Rect As New RectangleF(m_BZR.ZoomedBildPosition, m_BZR.ZoomedBildSize)
                    Dim ZoomRect As RectangleF = m_Selector.Rectangle

                    'Dieses Rechteck enthlt den zu zoomenden Ausschnitt, bezogen auf den Rand des Controls
                    Rect.Intersect(ZoomRect)

                    'Bentigt wird aber der Ausschnitt, bezogen auf den den Rand des Image 
                    Dim NewRect As New RectangleF(Rect.X - m_BZR.ZoomedBildPosition.X, Rect.Y - m_BZR.ZoomedBildPosition.Y, Rect.Width, Rect.Height)
                    Dim UnzoomedRect As RectangleF = m_BZR.UnzoomRectangle(NewRect)
                    If m_Bild.Beschriftungen.SelectedRE Is Nothing Then
                        Dim Txt As String = InputBox("Bitte eine Beschriftung fr das ausgewhlte Rechteck angeben", "PhotoCollector")
                        If Txt.Trim = "" Then Exit Sub
                        Dim NeuRE As New BeschriftungsRechteck(Txt.Trim)
                        m_Bild.Beschriftungen.Add(NeuRE)
                        m_Bild.Beschriftungen.SetSelected(NeuRE, Me)
                    End If
                    m_Bild.Beschriftungen.SelectedRE.Rect = New Rectangle(UnzoomedRect.X, UnzoomedRect.Y, UnzoomedRect.Width, UnzoomedRect.Height)
                End If
                'Case PictureControlModes.SelectMode
                '    If AcMoveMode <> BeschriftungsRechteckHitTestResults.None AndAlso AcHittedBeschriftungsRechteck IsNot Nothing Then
                '        Dim MovePt As New PointF(CInt(m_Selector.EndPoint.X - m_Selector.StartPoint.X), CInt(m_Selector.EndPoint.Y - m_Selector.StartPoint.Y))
                '        Dim UnzoomedPt As PointF = m_BZR.UnZoomPoint(MovePt)

                '        Dim ORect As Rectangle = AcHittedBeschriftungsRechteck.Rect
                '        Dim OrigRect As New Rectangle(ORect.X, ORect.Y, ORect.Width, ORect.Height)

                '        Select Case AcMoveMode
                '            Case BeschriftungsRechteckHitTestResults.Left
                '                OrigRect.X += UnzoomedPt.X
                '                OrigRect.Width -= UnzoomedPt.X
                '            Case BeschriftungsRechteckHitTestResults.Top
                '                OrigRect.Y += UnzoomedPt.Y
                '                OrigRect.Height -= UnzoomedPt.Y
                '            Case BeschriftungsRechteckHitTestResults.Bottom
                '                OrigRect.Height += UnzoomedPt.Y
                '            Case BeschriftungsRechteckHitTestResults.Right
                '                OrigRect.Width += UnzoomedPt.X
                '            Case BeschriftungsRechteckHitTestResults.MoveArea
                '                OrigRect.X += UnzoomedPt.X
                '                OrigRect.Y += UnzoomedPt.Y
                '        End Select

                '        If OrigRect.Width < 5 Then
                '            OrigRect.Width = 5
                '        End If
                '        If OrigRect.Height < 5 Then
                '            OrigRect.Height = 5
                '        End If
                '        AcHittedBeschriftungsRechteck.Rect = OrigRect
                '    End If
            Case PictureControlModes.Hand
                Dim MoveSize As New Size(CInt(m_Selector.EndPoint.X - m_Selector.StartPoint.X), CInt(m_Selector.EndPoint.Y - m_Selector.StartPoint.Y))
                Dim Moved As Boolean = False
                If Me.VScrollBar1.Visible Then
                    Dim ExtremeVal As ExtremeValues = ExtremeValues.Middle
                    Dim NewVValue As Integer = VScrollBar1.Value - MoveSize.Height
                    If NewVValue <= 0 Then
                        NewVValue = 0
                        ExtremeVal = ExtremeValues.LeftMost
                    ElseIf NewVValue >= VScrollBar1.Maximum Then
                        NewVValue = VScrollBar1.Maximum
                        ExtremeVal = ExtremeValues.RightMost
                    End If
                    VScrollBar1.Value = NewVValue

                    m_BZR.SetNewTopPosition(NewVValue * -1, ExtremeVal, True)
                    Moved = True
                End If

                If Me.HScrollBar1.Visible Then
                    Dim ExtremeVal As ExtremeValues = ExtremeValues.Middle
                    Dim NewHValue As Integer = HScrollBar1.Value - MoveSize.Width
                    If NewHValue <= 0 Then
                        NewHValue = 0
                        ExtremeVal = ExtremeValues.LeftMost
                    ElseIf NewHValue >= HScrollBar1.Maximum Then
                        NewHValue = HScrollBar1.Maximum
                        ExtremeVal = ExtremeValues.RightMost
                    End If
                    HScrollBar1.Value = NewHValue

                    m_BZR.SetNewLeftPosition(NewHValue * -1, ExtremeVal, True)
                    Moved = True
                End If

                If Moved Then
                    Me.ZoomBeschriftungsPainter1.PaintImage(m_Image, m_BZR.ZoomedBildPosition, m_BZR.ZoomedBildSize, m_Bild.Beschriftungen, m_BZR.ScaleFactor)
                End If
        End Select
    End Sub
    Private AcMoveMode As BeschriftungsRechteckHitTestResults = BeschriftungsRechteckHitTestResults.None
    Dim AcHittedBeschriftungsRechteck As BeschriftungsRechteck = Nothing
    Private Sub SetCursor(ByVal p As PointF)
        If m_Image Is Nothing Then
            Cursor = Cursors.Default
            Exit Sub
        End If
        If IsPointInImage(p) Then
            Select Case m_Mode
                Case PictureControlModes.Hand
                    If Me.VScrollBar1.Visible OrElse Me.HScrollBar1.Visible Then
                        Cursor = m_HandCursor
                    Else
                        Cursor = Cursors.Default
                    End If

                Case PictureControlModes.ZoomIn : Cursor = m_PlusCursor
                Case PictureControlModes.ZoomOut : Cursor = m_MinusCursor
                Case PictureControlModes.DrawRectangle : Cursor = m_PencilCursor
                Case PictureControlModes.SelectMode


                    Dim NewPoint As New PointF(p.X - m_BZR.ZoomedBildPosition.X, p.Y - m_BZR.ZoomedBildPosition.Y)
                    Dim UnzoomedPoint As PointF = m_BZR.UnZoomPoint(NewPoint)
                    AcMoveMode = BeschriftungsRechteckHitTestResults.None
                    AcHittedBeschriftungsRechteck = Nothing
                    For Each BZR As BeschriftungsRechteck In m_Bild.Beschriftungen
                        Dim erg As BeschriftungsRechteckHitTestResults = BZR.HitTest(UnzoomedPoint)
                        If erg <> BeschriftungsRechteckHitTestResults.None Then
                            AcMoveMode = erg
                            AcHittedBeschriftungsRechteck = BZR
                            Exit For
                        End If
                    Next

                    Select Case AcMoveMode
                        Case BeschriftungsRechteckHitTestResults.None
                            Cursor = Cursors.Default
                        Case BeschriftungsRechteckHitTestResults.Bottom, BeschriftungsRechteckHitTestResults.Top
                            Cursor = Cursors.SizeNS
                        Case BeschriftungsRechteckHitTestResults.Left, BeschriftungsRechteckHitTestResults.Right
                            Cursor = Cursors.SizeWE
                        Case BeschriftungsRechteckHitTestResults.MoveArea
                            Cursor = Cursors.SizeAll
                    End Select


            End Select
        Else
            Cursor = Cursors.Default
        End If
    End Sub
    Public Sub FitToControl()
        If m_Image Is Nothing Then Exit Sub
        m_BZR.FitToControl(Me.VScrollBar1.Visible, Me.HScrollBar1.Visible)
        ScrollBarsUndBild_Neu_Anzeigen()
        m_Zoom = m_BZR.GetZoom
        RaiseEvent ZoomChanged()
    End Sub
    Public Sub ZoomPixels()
        If m_Image Is Nothing Then Exit Sub
        m_BZR.ZoomPixels()
        ScrollBarsUndBild_Neu_Anzeigen()
        m_Zoom = m_BZR.GetZoom
        RaiseEvent ZoomChanged()
    End Sub

    Private Function IsPointInImage(ByVal p As PointF) As Boolean
        Dim Rect As New RectangleF(m_BZR.ZoomedBildPosition, m_BZR.ZoomedBildSize)
        Rect.Intersect(New Rectangle(0, 0, Me.ZoomBeschriftungsPainter1.Size.Width, Me.ZoomBeschriftungsPainter1.Size.Height))
        Return Rect.Contains(p)
    End Function

    Public Sub EditColors()
        GC.Collect()
        If Me.m_Image Is Nothing Then Exit Sub
        Dim frm As New frm_EditColors(Me, Me.m_EditColorValues)
        frm.ShowDialog()
    End Sub

    Public Sub New()

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fgen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.
        Dim Ass As Assembly = Assembly.GetExecutingAssembly()
        Dim AssName As String = Ass.FullName.Substring(0, Ass.FullName.IndexOf(","))
        m_PlusCursor = New Cursor(Ass.GetManifestResourceStream(AssName & ".Plus.cur"))
        m_MinusCursor = New Cursor(Ass.GetManifestResourceStream(AssName & ".Minus.cur"))
        m_HandCursor = New Cursor(Ass.GetManifestResourceStream(AssName & ".Hand.cur"))
        m_PencilCursor = New Cursor(Ass.GetManifestResourceStream(AssName & ".Pencil.cur"))
        Me.MinimumSize = New Size(50, 50)
    End Sub


    ReadOnly Property BaseImage() As Image Implements IEditColorsControl.BaseImage
        Get
            Return m_BaseImage
        End Get
    End Property
    ReadOnly Property Image() As Image Implements IEditColorsControl.Image
        Get
            Return m_Image
        End Get
    End Property
    Public Sub SetTemporaryImage(ByVal Img As Image) Implements IEditColorsControl.SetTemporaryImage
        m_Image = Img
        Me.ZoomBeschriftungsPainter1.PaintImage(m_Image, m_BZR.ZoomedBildPosition, m_BZR.ZoomedBildSize, m_Bild.Beschriftungen, m_BZR.ScaleFactor)
    End Sub
    WriteOnly Property EditColorValues() As EditColorValues Implements IEditColorsControl.EditColorValues
        Set(ByVal value As EditColorValues)
            m_EditColorValues = value
        End Set
    End Property
End Class
