Public Class ZoomBeschriftungsPainter
    'Ein Ownerdrawn Control, das ein Bild mit vorher festgelegter Größe und Location zeichnen kann
    Private m_BMP As Bitmap = Nothing

    Private m_Image As Image = Nothing
    Private m_Position As PointF = PointF.Empty
    Private m_Size As SizeF = SizeF.Empty
    Private m_OldControlSize As Size = Drawing.Size.Empty
    Private m_Selector As Selector

    Private m_ScaleFactor As Double = 0.0R

    Private WithEvents m_BeschriftungsRechtecke As BeschriftungsRechteckListe

    Public Sub PaintImage(ByVal Img As Image, ByVal Pos As PointF, ByVal Size As SizeF, ByVal BeschriftungsRechtecke As BeschriftungsRechteckListe, ByVal ScaleFactor As Double)
        m_BeschriftungsRechtecke = BeschriftungsRechtecke
        If m_Image IsNot Img OrElse m_Position <> Pos OrElse m_Size <> Size OrElse m_OldControlSize <> Me.Size Then
            m_ScaleFactor = ScaleFactor
            m_Image = Img
            m_Position = Pos
            m_Size = Size
            m_OldControlSize = Me.Size
            m_BMP = Nothing
            Invalidate()
        End If
    End Sub
    Public Sub PaintSelector(ByVal Sel As Selector)
        If Sel Is Nothing Then
            If m_Selector IsNot Nothing Then
                m_Selector = Nothing
                'm_BMP = Nothing
                Invalidate()
            End If
        Else
            If m_Selector Is Nothing Then
                m_Selector = New Selector(Sel.StartPoint, Sel.EndPoint)
                'm_BMP = Nothing
                Invalidate()
            Else
                If m_Selector.StartPoint <> Sel.StartPoint OrElse m_Selector.EndPoint <> Sel.EndPoint Then
                    m_Selector = New Selector(Sel.StartPoint, Sel.EndPoint)
                    'm_BMP = Nothing
                    Invalidate()
                End If
            End If
        End If
    End Sub

    Protected Overrides Sub OnPaint(ByVal pe As System.Windows.Forms.PaintEventArgs)
        MyBase.OnPaint(pe)

        'Benutzerdefinierten Zeichnungscode hier einfügen

        Dim gr As Graphics = pe.Graphics
        If m_BMP Is Nothing Then
            m_BMP = New Bitmap(Me.Width, Me.Height)
            Dim g As Graphics = Graphics.FromImage(m_BMP)
            g.FillRectangle(SystemBrushes.ControlLight, New Rectangle(0, 0, Me.Width, Me.Height))

            If m_Image IsNot Nothing Then
                g.DrawImage(m_Image, m_Position.X, m_Position.Y, m_Size.Width, m_Size.Height)
            End If

        End If
        gr.DrawImage(m_BMP, 0, 0)

        If m_Selector IsNot Nothing Then
            gr.DrawRectangle(Pens.Red, m_Selector.Rectangle.X, m_Selector.Rectangle.Y, m_Selector.Rectangle.Width, m_Selector.Rectangle.Height)
        End If

        If m_BeschriftungsRechtecke IsNot Nothing Then
            For Each RE As BeschriftungsRechteck In m_BeschriftungsRechtecke
                Dim DrawRE As New RectangleF(m_Position.X + CSng(RE.Left) * m_ScaleFactor, m_Position.Y + CSng(RE.Top) * m_ScaleFactor, CSng(RE.Width) * m_ScaleFactor, CSng(RE.Height) * m_ScaleFactor)
                If RE Is m_BeschriftungsRechtecke.SelectedRE Then
                    Dim SelPen As New Pen(Color.Yellow)
                    SelPen.DashStyle = Drawing2D.DashStyle.Dash
                    gr.DrawRectangle(SelPen, DrawRE.X, DrawRE.Y, DrawRE.Width, DrawRE.Height)
                    gr.DrawString(RE.Text, Me.Font, Brushes.Yellow, DrawRE.X, DrawRE.Y)
                    SelPen.Dispose()
                Else
                    gr.DrawRectangle(Pens.Yellow, DrawRE.X, DrawRE.Y, DrawRE.Width, DrawRE.Height)
                    gr.DrawString(RE.Text, Me.Font, Brushes.Yellow, DrawRE.X, DrawRE.Y)
                End If

            Next
        End If



    End Sub

    Public Sub New()

        ' Dieser Aufruf ist für den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fügen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.
        Me.SetStyle(ControlStyles.DoubleBuffer _
            Or ControlStyles.UserPaint _
            Or ControlStyles.AllPaintingInWmPaint, _
            True)

    End Sub

    Private Sub m_BeschriftungsRechtecke_Changed() Handles m_BeschriftungsRechtecke.Changed
        Invalidate()
    End Sub
End Class
