Imports System.ComponentModel
Public Class SortOptionZoomListView
    Private m_Initialisation As Boolean = False


    Private m_DS As Datensammlung
    WriteOnly Property DS() As Datensammlung
        Set(ByVal value As Datensammlung)
            m_DS = value
        End Set
    End Property

    Private Sub SortOptionZoomListView_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If Not Initialisiert Then Initialisieren()
    End Sub
    Private Initialisiert As Boolean = False
    Private Sub Initialisieren()
        m_Initialisation = True
        For I As Integer = 0 To 3
            Me.ToolStripComboBoxSortierung.Items.Add(CType(I, BildSortierTypen))
        Next
        Me.ToolStripComboBoxSortierung.SelectedIndex = 0
        Me.ToolStripComboBoxGroesse.SelectedIndex = 0
        m_Initialisation = False

        Initialisiert = True
    End Sub


    <Category("Appearance"), Description("Kantenlnge der anzuzeigenden Thumbnails")> _
    Property PictureWidth() As Integer
        Get
            Return Me.ZoomListView1.PictureWidth
        End Get
        Set(ByVal value As Integer)
            Me.ZoomListView1.PictureWidth = value
        End Set
    End Property
    <Category("Appearance"), Description("Gibt an und legt fest, ob per Drag & Drop aus dem Control herausgezogene Bilder gelscht werden sollen")> _
    Property AllowsRemoving() As Boolean
        Get
            Return Me.ZoomListView1.AllowsRemoving
        End Get
        Set(ByVal value As Boolean)
            Me.ZoomListView1.AllowsRemoving = value
        End Set
    End Property
    WriteOnly Property Bilder() As List(Of Bild)
        'Get
        '    Return Me.ZoomListView1.Bilder
        'End Get
        Set(ByVal value As List(Of Bild))
            If Not Initialisiert Then Initialisieren()
            Me.ZoomListView1.Bilder = value
            'm_Initialisation = True
            'Me.ToolStripComboBoxSortierung.SelectedIndex = 0
            'm_Initialisation = False
        End Set
    End Property

    Private Sub ToolStripComboBoxSortierung_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ToolStripComboBoxSortierung.SelectedIndexChanged
        If m_Initialisation Then Exit Sub
        Me.ZoomListView1.SortierTyp = ToolStripComboBoxSortierung.SelectedItem
    End Sub

    Private Sub ToolStripComboBoxGroesse_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles ToolStripComboBoxGroesse.KeyDown
        If e.KeyCode = Keys.Enter Then
            Try
                Dim Nr As Integer = ToolStripComboBoxGroesse.Text
                If Nr > 99 Then
                    Me.ZoomListView1.PictureWidth = Nr
                    Me.ToolStripComboBoxGroesse.Text = Me.ZoomListView1.PictureWidth.ToString
                End If
            Catch ex As Exception
                Me.ToolStripComboBoxGroesse.Text = Me.ZoomListView1.PictureWidth.ToString
            End Try
        End If
    End Sub

    Private Sub ToolStripComboBoxGroesse_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ToolStripComboBoxGroesse.SelectedIndexChanged
        If m_Initialisation Then Exit Sub
        Me.ZoomListView1.PictureWidth = CInt(ToolStripComboBoxGroesse.Text)
    End Sub

    Public Event SelectedBilder_Geaendert()

    ReadOnly Property SelectedBilder() As List(Of Bild)
        Get
            Return ZoomListView1.SelectedBilder
        End Get
    End Property
    Private Sub ZoomListView1_SelectedBilder_Geaendert() Handles ZoomListView1.SelectedBilder_Geaendert
        Dim SelBilder As List(Of Bild) = ZoomListView1.SelectedBilder
        If SelBilder.Count = 0 Then
            Me.ToolStripButtonDeleteBild.Enabled = False
        Else
            Me.ToolStripButtonDeleteBild.Enabled = True
        End If
        RaiseEvent SelectedBilder_Geaendert()
    End Sub

    Private Sub ToolStripButtonDeleteBild_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles ToolStripButtonDeleteBild.Click
        If ZoomListView1.SelectedBilder.Count > 0 Then

            If ZoomListView1.Bilder Is MainBildListe Then
                If m_DS Is Nothing Then Exit Sub
                Dim Frage As String = ""
                If ZoomListView1.SelectedBilder.Count = 1 Then
                    Frage = "Dieses Bild unwiederruflich lschen?"
                Else
                    Frage = "Diese Bilder unwiederruflich lschen?"
                End If
                If MessageBox.Show(Frage, "PhotoCollector", MessageBoxButtons.YesNo, MessageBoxIcon.Warning) = DialogResult.No Then Exit Sub

                Dim BilderToDelete As New List(Of Bild)
                BilderToDelete.AddRange(ZoomListView1.SelectedBilder.ToArray)
                For Each Bld As Bild In BilderToDelete
                    m_DS.Bild_Loeschen(Bld, False)
                Next
            Else
                Dim BilderToDelete As New List(Of Bild)
                BilderToDelete.AddRange(ZoomListView1.SelectedBilder.ToArray)
                ZoomListView1.RemoveAllSelectedItems(BilderToDelete)
            End If


        End If
    End Sub
End Class
