'Enthlt die Zeilen- und Spaltenverteilungslogik fr das ZomListView-Control
Public Class ZoomListViewPositioner
    Private VBar As New VScrollBar

    Private m_ItemCount As Integer = 0
    Private m_NotwendigeHoehe As Integer = 0
    Private m_AnzahlSpalten As Integer = 0
    Private m_AnzahlZeilen As Integer = 0
    Private m_PictureWidth As Integer = 100
    Private m_TextZeilenhoehe As Integer = 0
    Private m_InnerDistance As Integer = 10
    Private m_ControlSize As Size = Size.Empty

    Private m_ItemPositions As New List(Of Point)
    Private m_ItemCountChanged As Boolean = True
    Private m_PictureWidthChanged As Boolean = True
    Private m_InnerDistanceChanged As Boolean = True

    Private m_ColumnPositions() As Integer
    Private m_RowPositions() As Integer

    Public Event Changed()
    ReadOnly Property NotwendigeHoehe() As Integer
        Get
            Return m_NotwendigeHoehe
        End Get
    End Property
    ReadOnly Property AnzahlSpalten() As Integer
        Get
            Return m_AnzahlSpalten
        End Get
    End Property
    ReadOnly Property AnzahlZeilen() As Integer
        Get
            Return m_AnzahlZeilen
        End Get
    End Property
    ReadOnly Property ColumnPositions() As Integer()
        Get
            Return m_ColumnPositions
        End Get
    End Property
    ReadOnly Property RowPositions() As Integer()
        Get
            Return m_RowPositions
        End Get
    End Property
    ReadOnly Property ItemPositions() As List(Of Point)
        Get
            Return m_ItemPositions
        End Get
    End Property
    ReadOnly Property ZeilenHoehe() As Integer
        Get
            Return m_InnerDistance + m_PictureWidth + m_TextZeilenhoehe * 2
        End Get
    End Property

    WriteOnly Property ItemCount() As Integer
        Set(ByVal value As Integer)
            If m_ItemCount <> value Then
                m_ItemCount = value
                m_ItemCountChanged = True
                Berechnen()
            End If
        End Set
    End Property

    Property PictureWidth() As Integer
        Get
            Return m_PictureWidth
        End Get
        Set(ByVal value As Integer)
            Dim TmpValue As Integer = value
            If TmpValue > 400 Then
                TmpValue = 400
            ElseIf TmpValue < 100 Then
                TmpValue = 100
            End If

            If m_PictureWidth <> TmpValue Then
                m_PictureWidth = TmpValue
                m_PictureWidthChanged = True
                Berechnen()
            End If

        End Set
    End Property


    Property InnerDistance() As Integer
        Get
            Return m_InnerDistance
        End Get
        Set(ByVal value As Integer)
            If m_InnerDistance <> value Then
                m_InnerDistance = value
                m_InnerDistanceChanged = True
                Berechnen()
            End If
        End Set
    End Property

    WriteOnly Property ControlSize() As Size
        Set(ByVal value As Size)
            If m_ControlSize.Width <> value.Width Or m_ControlSize.Height <> value.Height Then
                m_ControlSize = value
                Berechnen()
            End If
        End Set
    End Property

    Public Sub New(ByVal ItemCount As Integer, ByVal PictureWidth As Integer, ByVal TextZeilenhoehe As Integer, ByVal InnerDistance As Integer, ByVal ControlSize As Size)
        m_ItemCount = ItemCount
        m_PictureWidth = PictureWidth
        m_TextZeilenhoehe = TextZeilenhoehe
        m_InnerDistance = InnerDistance
        m_ControlSize = ControlSize

        Berechnen()
    End Sub


    Private Sub Berechnen()

        'Zeilenzahl ermitteln

        'zuerst ohne ScrollBar ausrechnen
        Dim SpaltenMitScrollbar As Integer = AnzahlSpalten_Liefern(True)
        Dim SpaltenOhneScrollbar As Integer = AnzahlSpalten_Liefern(False)


        Dim TmpNotwendigeHoehe As Integer
        Dim TmpAnzahlSpalten As Integer
        Dim TmpAnzahlZeilen As Integer

        If SpaltenMitScrollbar = SpaltenOhneScrollbar Then
            TmpAnzahlSpalten = SpaltenMitScrollbar
            TmpAnzahlZeilen = (m_ItemCount + TmpAnzahlSpalten - 1) \ TmpAnzahlSpalten
            'AnzahlZeilen kann hier Null sein, wenn ItemCount=0

            TmpNotwendigeHoehe = m_InnerDistance + ZeilenHoehe * TmpAnzahlZeilen
        Else
            Dim AnzahlZeilenOhneScrollbar As Integer = (m_ItemCount + SpaltenOhneScrollbar - 1) \ SpaltenOhneScrollbar
            Dim NotwendigeHoeheOhneScrollbar As Integer = m_InnerDistance + ZeilenHoehe * AnzahlZeilenOhneScrollbar
            If NotwendigeHoeheOhneScrollbar < m_ControlSize.Height Then
                'keine ScrollBar notwendig
                TmpAnzahlSpalten = SpaltenOhneScrollbar
                TmpAnzahlZeilen = AnzahlZeilenOhneScrollbar
                TmpNotwendigeHoehe = NotwendigeHoeheOhneScrollbar
            Else
                'ScrollBar ist notwendig
                Dim AnzahlZeilenMitScrollbar As Integer = (m_ItemCount + SpaltenMitScrollbar - 1) \ SpaltenMitScrollbar
                Dim NotwendigeHoeheMitScrollbar As Integer = m_InnerDistance + ZeilenHoehe * AnzahlZeilenMitScrollbar
                TmpAnzahlSpalten = SpaltenMitScrollbar
                TmpAnzahlZeilen = AnzahlZeilenMitScrollbar
                TmpNotwendigeHoehe = NotwendigeHoeheMitScrollbar
            End If
        End If


        If m_ItemCountChanged OrElse (TmpAnzahlSpalten <> m_AnzahlSpalten) OrElse (TmpAnzahlZeilen <> m_AnzahlZeilen) OrElse (m_PictureWidthChanged) OrElse (TmpNotwendigeHoehe <> m_NotwendigeHoehe) OrElse m_InnerDistanceChanged Then
            'In diesen Fllen mssen die Positionen unbedingt neu berechnet werden


            m_AnzahlSpalten = TmpAnzahlSpalten
            m_AnzahlZeilen = TmpAnzahlZeilen
            m_NotwendigeHoehe = TmpNotwendigeHoehe

            If m_AnzahlSpalten = 0 Then
                ReDim m_ColumnPositions(0)
                m_ColumnPositions(0) = m_InnerDistance
            Else
                ReDim m_ColumnPositions(m_AnzahlSpalten - 1)
                Dim SpaltenBreite As Integer = m_PictureWidth + m_InnerDistance
                For I As Integer = 0 To m_AnzahlSpalten - 1
                    m_ColumnPositions(I) = m_InnerDistance + SpaltenBreite * I
                Next
            End If

            If m_AnzahlZeilen = 0 Then
                ReDim m_RowPositions(0)
                m_RowPositions(0) = m_InnerDistance
            Else
                ReDim m_RowPositions(m_AnzahlZeilen - 1)
                For I As Integer = 0 To m_AnzahlZeilen - 1
                    m_RowPositions(I) = m_InnerDistance + ZeilenHoehe * I
                Next
            End If

            m_ItemPositions.Clear()

            Dim ZeilenIndex As Integer = 0
            Dim SpaltenIndex As Integer = 0
            If m_ItemCount > 0 Then
                For I As Integer = 0 To m_ItemCount - 1
                    m_ItemPositions.Add(New Point(m_ColumnPositions(SpaltenIndex), m_RowPositions(ZeilenIndex)))
                    SpaltenIndex += 1

                    If SpaltenIndex = m_AnzahlSpalten Then
                        ZeilenIndex += 1
                        SpaltenIndex = 0
                    End If
                Next
            End If


            m_PictureWidthChanged = False
            m_ItemCountChanged = False
            m_InnerDistanceChanged = False

            RaiseEvent Changed()

        End If


    End Sub

    Private Function AnzahlSpalten_Liefern(ByVal SrollBarBeruecksichtigt As Boolean) As Integer

        Dim RestBreite As Integer = m_ControlSize.Width - m_InnerDistance
        If SrollBarBeruecksichtigt Then RestBreite -= VBar.Width

        Dim AnzahlSpalten As Integer = RestBreite \ (m_InnerDistance + m_PictureWidth)
        If AnzahlSpalten = 0 Then AnzahlSpalten = 1


        Return AnzahlSpalten
    End Function

    Public Function GetMouseHooveredIndex(ByVal MousePosition As Point) As Integer
        Dim ZellHoehe As Integer = m_PictureWidth + m_TextZeilenhoehe * 2
        Dim Zaehler As Integer = 0
        For Each Pt As Point In m_ItemPositions
            If Pt.X <= MousePosition.X AndAlso Pt.Y <= MousePosition.Y AndAlso Pt.X + m_PictureWidth >= MousePosition.X AndAlso Pt.Y + ZellHoehe >= MousePosition.Y Then
                Return Zaehler
            End If
            Zaehler += 1
        Next
        Return -1
    End Function
    Public Function GetMoveTargetIndex(ByVal MousePoint As Point) As ZoomListViewInsertionMark
        Dim Zeile As Integer = 0
        Dim Spalte As Integer = 0

        '1)Spalte ermitteln
        Dim HalbPicBreite As Single = CSng(m_PictureWidth) / 2.0F
        Spalte = (CSng(MousePoint.X) + HalbPicBreite) \ CSng(m_InnerDistance + m_PictureWidth)

        Dim HalbInternHoehe As Single = CSng(m_InnerDistance) / 2.0F
        Zeile = (CSng(MousePoint.Y) - HalbInternHoehe) \ ZeilenHoehe

        Dim ZielIndex As Integer = Spalte + Zeile * m_AnzahlSpalten
        If ZielIndex > m_ItemCount Then
            ZielIndex = m_ItemCount
            Spalte = ZielIndex - Zeile * m_AnzahlSpalten
        End If

        Dim XPos As Single = CSng(Spalte * (m_InnerDistance + m_PictureWidth)) + CSng(m_InnerDistance) / 2.0F
        Dim YPos As Integer = CSng(Zeile * ZeilenHoehe) + CSng(m_InnerDistance) / 2.0F

        Return New ZoomListViewInsertionMark(Zeile, Spalte, ZielIndex, New PointF(XPos, YPos), m_InnerDistance + m_PictureWidth)
    End Function

    Public Function GetAutoScrollPosition(ByVal IndexOfItem As Integer) As Integer
        Dim PosY As Integer = m_ItemPositions(IndexOfItem).Y - 10
        'Normalerweise wrde PosY als AutoscrollPosition.Y ausreichen, nur nicht, wenn 
        'es nach dem Scrollen ganz unten im Fenster erscheinen wrde

        If m_NotwendigeHoehe > m_ControlSize.Height Then
            Dim MaxHoehe As Integer = m_NotwendigeHoehe - m_ControlSize.Height
            If MaxHoehe < PosY Then
                Return MaxHoehe
            End If
        End If
        Return PosY

        'm_NotwendigeHoehe
        'm_ControlSize
    End Function


End Class


