Public Class BildZeichenRechteck
    'Diese Klasse enthlt die Layout-Logik fr die ZoomPicBox

    Private m_OriginalBildGroesse As Size = Size.Empty
    Private m_OriginalBildZoomMittelpunkt As PointF = PointF.Empty

    Private m_ZoomedBildSize As SizeF = SizeF.Empty
    Private m_ZoomedBildPosition As PointF = PointF.Empty

    Private m_ControlSize As Size = Size.Empty
    Private m_ScaleFactor As Double = 1.0R
    Private m_Zoom As Single = 100.0F

    ReadOnly Property ZoomedBildSize() As SizeF
        Get
            Return m_ZoomedBildSize
        End Get
    End Property
    ReadOnly Property ZoomedBildPosition() As PointF
        Get
            Return m_ZoomedBildPosition
        End Get
    End Property
    WriteOnly Property ControlSize() As Size
        Set(ByVal value As Size)
            m_ControlSize = value
            ResizeAction()
        End Set
    End Property
    ReadOnly Property ScaleFactor() As Double
        Get
            Return m_ScaleFactor
        End Get
    End Property
    ReadOnly Property OriginalBildGroesse() As Size
        Get
            Return m_OriginalBildGroesse
        End Get
    End Property
    Public Sub New(ByVal ControlSize As Size, ByVal OriginalBildGroesse As Size)
        m_ControlSize = ControlSize
        m_OriginalBildGroesse = OriginalBildGroesse
        m_OriginalBildZoomMittelpunkt = New PointF(CSng(m_OriginalBildGroesse.Width) / 2.0F, CSng(m_OriginalBildGroesse.Height) / 2.0F)
        StartSkalierung()
    End Sub
    Private Sub ResizeAction()
        'Hierbei wird nur der alte Bild-Mittelpunkt wieder hergestellt

        Dim ActualMidPoint As PointF = ZoomPoint(m_OriginalBildZoomMittelpunkt)


        Dim LeftDistance As Single = 0.0F
        Dim TopDistance As Single = 0.0F

        If m_ZoomedBildSize.Width < CSng(m_ControlSize.Width) Then
            LeftDistance = (CSng(m_ControlSize.Width) - m_ZoomedBildSize.Width) / 2.0F
        ElseIf m_ZoomedBildSize.Width = CSng(m_ControlSize.Width) Then
            LeftDistance = 0.0F
        Else
            'Das anzuzeigende Bild ist breiter als das Control
            Dim HalfControl As Single = CSng(m_ControlSize.Width) / 2.0F

            ''Das anzuzeigende Bild ist breiter als das Control
            Dim AreaL As Single = HalfControl - ActualMidPoint.X
            Dim AreaR As Single = HalfControl - (m_ZoomedBildSize.Width - ActualMidPoint.X)

            If AreaL > 0.0F Then
                LeftDistance = 0.0F
            ElseIf AreaR > 0.0F Then
                LeftDistance = (CSng(m_ControlSize.Width) - m_ZoomedBildSize.Width) '* -1.0F
            Else
                LeftDistance = HalfControl - ActualMidPoint.X
            End If
        End If

        If m_ZoomedBildSize.Height < CSng(m_ControlSize.Height) Then
            TopDistance = (CSng(m_ControlSize.Height) - m_ZoomedBildSize.Height) / 2.0F
        ElseIf m_ZoomedBildSize.Height = CSng(m_ControlSize.Height) Then
            TopDistance = 0.0F
        Else
            'Das anzuzeigende Bild ist breiter als das Control
            Dim HalfControl As Single = CSng(m_ControlSize.Height) / 2.0F

            ''Das anzuzeigende Bild ist breiter als das Control
            Dim AreaL As Single = HalfControl - ActualMidPoint.Y
            Dim AreaR As Single = HalfControl - (m_ZoomedBildSize.Height - ActualMidPoint.Y)

            If AreaL > 0.0F Then
                TopDistance = 0.0F
            ElseIf AreaR > 0.0F Then
                TopDistance = (CSng(m_ControlSize.Height) - m_ZoomedBildSize.Height) '* -1.0F
            Else
                TopDistance = HalfControl - ActualMidPoint.Y
            End If
        End If

        m_ZoomedBildPosition = New PointF(LeftDistance, TopDistance)

    End Sub
    Public Sub SetNewLeftPosition(ByVal NewValue As Single, ByVal ExtremePos As ExtremeValues, ByVal WithResize As Boolean)
        Dim TopPos As Single = m_ZoomedBildPosition.Y
        m_ZoomedBildPosition = New PointF(NewValue, TopPos)

        Dim YPos As Single = m_OriginalBildZoomMittelpunkt.Y
        If ExtremePos = ExtremeValues.LeftMost Then
            m_OriginalBildZoomMittelpunkt = New PointF(0.0F, YPos)
        ElseIf ExtremePos = ExtremeValues.RightMost Then
            m_OriginalBildZoomMittelpunkt = New PointF(CSng(m_OriginalBildGroesse.Width), YPos)
        Else
            Dim AngezeigtesRechteck As RectangleF = New RectangleF(m_ZoomedBildPosition, m_ControlSize)
            AngezeigtesRechteck = UnzoomRectangle(AngezeigtesRechteck)

            'Dim OrigX As Single = (NewValue + CSng(m_ControlSize.Width) / 2.0F) / m_ScaleFactor
            m_OriginalBildZoomMittelpunkt = New PointF(AngezeigtesRechteck.Width / 2.0F - AngezeigtesRechteck.Left, YPos)
        End If
        If WithResize Then ResizeAction()
    End Sub
    Public Sub SetNewTopPosition(ByVal NewValue As Single, ByVal ExtremePos As ExtremeValues, ByVal WithResize As Boolean)
        Dim LeftPos As Single = m_ZoomedBildPosition.X
        m_ZoomedBildPosition = New PointF(LeftPos, NewValue)

        Dim XPos As Single = m_OriginalBildZoomMittelpunkt.X
        If ExtremePos = ExtremeValues.LeftMost Then
            m_OriginalBildZoomMittelpunkt = New PointF(XPos, 0.0F)
        ElseIf ExtremePos = ExtremeValues.RightMost Then
            m_OriginalBildZoomMittelpunkt = New PointF(XPos, CSng(m_OriginalBildGroesse.Height))
        Else
            Dim AngezeigtesRechteck As RectangleF = New RectangleF(m_ZoomedBildPosition, m_ControlSize)
            AngezeigtesRechteck = UnzoomRectangle(AngezeigtesRechteck)

            'Dim OrigY As Single = (NewValue + CSng(m_ControlSize.Height) / 2.0F) / m_ScaleFactor
            m_OriginalBildZoomMittelpunkt = New PointF(XPos, AngezeigtesRechteck.Height / 2.0F - AngezeigtesRechteck.Top)
        End If
        If WithResize Then ResizeAction()
    End Sub
    Public Sub ZoomOut()
        SetScaleFactor(m_ScaleFactor * 0.8F)
        m_ZoomedBildSize = New SizeF(m_ScaleFactor * m_OriginalBildGroesse.Width, m_ScaleFactor * m_OriginalBildGroesse.Height)
        ResizeAction()
    End Sub
    Public Sub ZoomIn()
        SetScaleFactor(m_ScaleFactor / 0.8F)
        m_ZoomedBildSize = New SizeF(m_ScaleFactor * m_OriginalBildGroesse.Width, m_ScaleFactor * m_OriginalBildGroesse.Height)
        ResizeAction()
    End Sub
    Public Sub ZoomIn(ByVal ZoomPoint As PointF)
        'ZoomPoint ist ein mit der Maus angeklickter Punkt innerhalb des angezeigten Bildes
        'Der ZoomPoint soll nach dem Zoomen mglichst wieder an derselben Stelle im Control 
        'erscheinen

        Dim PicturePoint As PointF = UnZoomPoint(ZoomPoint)

        SetScaleFactor(m_ScaleFactor / 0.8F)
        m_ZoomedBildSize = New SizeF(m_ScaleFactor * m_OriginalBildGroesse.Width, m_ScaleFactor * m_OriginalBildGroesse.Height)

        Dim NewZoomPoint As PointF = Me.ZoomPoint(PicturePoint)

        Dim NewZoomedBildPositionX As Single = m_ZoomedBildPosition.X - (NewZoomPoint.X - ZoomPoint.X)
        Dim NewZoomedBildPositionY As Single = m_ZoomedBildPosition.Y - (NewZoomPoint.Y - ZoomPoint.Y)

        SetNewLeftPosition(NewZoomedBildPositionX, ExtremeValues.Middle, False)
        SetNewTopPosition(NewZoomedBildPositionY, ExtremeValues.Middle, False)

        ResizeAction()
    End Sub
    Public Sub ZoomInToRectangle(ByVal ZoomRect As RectangleF, ByVal VScrollIsVisible As Boolean, ByVal HScrollIsVisible As Boolean)
        'Zuerst neuen Bild-Mittelpunkt ermitteln
        Dim OrigRect As RectangleF = UnzoomRectangle(ZoomRect)
        m_OriginalBildZoomMittelpunkt = New PointF(OrigRect.X + OrigRect.Width \ 2.0F, OrigRect.Y + OrigRect.Height \ 2.0F)
        If m_OriginalBildZoomMittelpunkt.X < 0.0F Then
            m_OriginalBildZoomMittelpunkt.X = 0.0F
        ElseIf m_OriginalBildZoomMittelpunkt.X > CSng(m_OriginalBildGroesse.Width) Then
            m_OriginalBildZoomMittelpunkt.X = CSng(m_OriginalBildGroesse.Width)
        End If

        If m_OriginalBildZoomMittelpunkt.Y < 0.0F Then
            m_OriginalBildZoomMittelpunkt.Y = 0.0F
        ElseIf m_OriginalBildZoomMittelpunkt.Y > CSng(m_OriginalBildGroesse.Height) Then
            m_OriginalBildZoomMittelpunkt.Y = CSng(m_OriginalBildGroesse.Height)
        End If

        'Dann den mglichen Skalierungs-Faktor ermitteln
        'Ziel ist, dass das gesamte Auswahl-Rechteck auf der Bildflche angezeigt werden kann

        Dim ControlWidth As Integer = m_ControlSize.Width
        Dim ControlHeight As Integer = m_ControlSize.Height
        If VScrollIsVisible Then ControlWidth += 17
        If HScrollIsVisible Then ControlHeight += 17

        Dim pw As Single = OrigRect.Width
        Dim ph As Single = OrigRect.Height
        Dim dw As Single = ControlWidth
        Dim dh As Single = ControlHeight

        If pw / ph > dw / dh Then
            SetScaleFactor(dw / pw)
        Else
            SetScaleFactor(dh / ph)
        End If

        m_ZoomedBildSize = New SizeF(m_ScaleFactor * m_OriginalBildGroesse.Width, m_ScaleFactor * m_OriginalBildGroesse.Height)
        ResizeAction()
    End Sub

    Private Sub SetScaleFactor(ByVal NewValue As Double)
        'Begrenzung des Skalierungs-Faktors
        'Ein skaliertes Bild soll hchstens eine Kantenlnge von 100000 Pixeln haben
        Dim ZValue As Double = NewValue
        Dim MaxWidth As Double = Math.Max(m_OriginalBildGroesse.Width, m_OriginalBildGroesse.Height)
        If MaxWidth * ZValue > 100000.0R Then
            ZValue = 100000.0R / MaxWidth
        End If
        m_ScaleFactor = ZValue
    End Sub

    Private Function ZoomPoint(ByVal originalPt As PointF) As PointF
        Dim newPt As New PointF(Me.m_ScaleFactor * originalPt.X, Me.m_ScaleFactor * originalPt.Y)
        Return newPt
    End Function
    Public Function UnZoomPoint(ByVal originalPt As PointF) As PointF
        Dim newPt As New PointF(originalPt.X / Me.m_ScaleFactor, originalPt.Y / Me.m_ScaleFactor)
        Return newPt
    End Function
    Public Function UnzoomRectangle(ByVal originalRect As RectangleF) As RectangleF
        Dim newRect As New RectangleF(originalRect.X / Me.m_ScaleFactor, originalRect.Y / Me.m_ScaleFactor, originalRect.Width / Me.m_ScaleFactor, originalRect.Height / Me.m_ScaleFactor)
        Return newRect
    End Function

    Private Sub StartSkalierung()
        Dim pw As Integer = m_OriginalBildGroesse.Width
        Dim ph As Integer = m_OriginalBildGroesse.Height
        Dim dw As Integer = m_ControlSize.Width
        Dim dh As Integer = m_ControlSize.Height

        If pw / ph > dw / dh Then
            SetScaleFactor(dw / pw)
        Else
            SetScaleFactor(dh / ph)
        End If

        Dim x As Single = (CSng(dw) - m_ScaleFactor * CSng(pw)) / 2.0F
        Dim y As Single = (CSng(dh) - m_ScaleFactor * CSng(ph)) / 2.0F
        m_ZoomedBildPosition = New PointF(x, y)
        m_ZoomedBildSize = New SizeF(m_ScaleFactor * pw, m_ScaleFactor * ph)
    End Sub

    Public Sub FitToControl(ByVal VScrollIsVisible As Boolean, ByVal HScrollIsVisible As Boolean)
        Dim Width As Integer = m_ControlSize.Width
        Dim Height As Integer = m_ControlSize.Height

        If VScrollIsVisible Then Width += 17
        If HScrollIsVisible Then Height += 17
        m_ControlSize = New Size(Width, Height)

        StartSkalierung()

        m_OriginalBildZoomMittelpunkt = New PointF(CSng(m_OriginalBildGroesse.Width) / 2.0F, CSng(m_OriginalBildGroesse.Height) / 2.0F)
        StartSkalierung()
    End Sub

    Public Sub ZoomPixels()
        m_ScaleFactor = 1.0R
        m_ZoomedBildSize = New SizeF(m_ScaleFactor * m_OriginalBildGroesse.Width, m_ScaleFactor * m_OriginalBildGroesse.Height)
        ResizeAction()
    End Sub
    Public Sub SetZoom(ByVal Value As Single)
        SetScaleFactor(Value / 100.0F)
        m_ZoomedBildSize = New SizeF(m_ScaleFactor * m_OriginalBildGroesse.Width, m_ScaleFactor * m_OriginalBildGroesse.Height)
        ResizeAction()
    End Sub

    Public Function GetZoom() As Single
        Dim Ausgangswert As Single = m_ScaleFactor * 100.0F

        If Ausgangswert < 1 Then
            Return Math.Round(Ausgangswert, 2)
        ElseIf Ausgangswert < 10 Then
            Return Math.Round(Ausgangswert, 1)
        Else
            Return Math.Round(Ausgangswert, 0)
        End If

    End Function
End Class
