Public Class Selector
    'Klasse, die ein Rechteck beim Ziehen der Maus ber das Control wiedergibt
    '(zum Hereinzoomen mit einem Rechteck-Ausschnitt oder Bewegen des Bildausschnitts
    'mit dem Hand-Tool)
    Private Start As PointF
    Private Current As PointF
    ReadOnly Property StartPoint() As PointF
        Get
            Return Start
        End Get
    End Property
    ReadOnly Property EndPoint() As PointF
        Get
            Return Current
        End Get
    End Property

    Public Sub New(ByVal p As PointF)
        Start = p
        Current = p
    End Sub 'New
    Public Sub New(ByVal p As Point)
        Dim Pt As New PointF(p.X, p.Y)
        Start = Pt
        Current = Pt
    End Sub 'New
    Public Sub New(ByVal Start As PointF, ByVal EndPoint As PointF)
        Me.Start = Start
        Me.Current = EndPoint
    End Sub

    Public Sub Update(ByVal p As PointF)
        Current = p
    End Sub 'Update

    Public ReadOnly Property Rectangle() As RectangleF
        Get
            Dim r As New RectangleF()
            r.X = IIf(Start.X <= Current.X, Start.X, Current.X)
            r.Y = IIf(Start.Y <= Current.Y, Start.Y, Current.Y)
            r.Width = Current.X - Start.X
            If r.Width < 0 Then
                r.Width *= -1.0F
            End If
            r.Height = Current.Y - Start.Y
            If r.Height < 0 Then
                r.Height *= -1.0F
            End If
            Return r
        End Get '
    End Property
End Class
