Public Class ZoomPainter
    'Ein Ownerdrawn Control, das ein Bild mit vorher festgelegter Größe und Location zeichnen kann
    Private m_BMP As Bitmap = Nothing

    Private m_Image As Image = Nothing
    Private m_Position As PointF = PointF.Empty
    Private m_Size As SizeF = SizeF.Empty
    Private m_OldControlSize As Size = Drawing.Size.Empty
    Private m_Selector As Selector

    Public Sub PaintImage(ByVal Img As Image, ByVal Pos As PointF, ByVal Size As SizeF)
        If m_Image IsNot Img OrElse m_Position <> Pos OrElse m_Size <> Size OrElse m_OldControlSize <> Me.Size Then
            m_Image = Img
            m_Position = Pos
            m_Size = Size
            m_OldControlSize = Me.Size
            m_BMP = Nothing
            Invalidate()
        End If
    End Sub
    Public Sub PaintSelector(ByVal Sel As Selector)
        If Sel Is Nothing Then
            If m_Selector IsNot Nothing Then
                m_Selector = Nothing
                'm_BMP = Nothing
                Invalidate()
            End If
        Else
            If m_Selector Is Nothing Then
                m_Selector = New Selector(Sel.StartPoint, Sel.EndPoint)
                'm_BMP = Nothing
                Invalidate()
            Else
                If m_Selector.StartPoint <> Sel.StartPoint OrElse m_Selector.EndPoint <> Sel.EndPoint Then
                    m_Selector = New Selector(Sel.StartPoint, Sel.EndPoint)
                    'm_BMP = Nothing
                    Invalidate()
                End If
            End If
        End If
    End Sub

    Protected Overrides Sub OnPaint(ByVal pe As System.Windows.Forms.PaintEventArgs)
        MyBase.OnPaint(pe)

        'Benutzerdefinierten Zeichnungscode hier einfügen

        Dim gr As Graphics = pe.Graphics
        If m_BMP Is Nothing Then
            m_BMP = New Bitmap(Me.Width, Me.Height)
            Dim g As Graphics = Graphics.FromImage(m_BMP)
            g.FillRectangle(SystemBrushes.ControlLight, New Rectangle(0, 0, Me.Width, Me.Height))

            If m_Image IsNot Nothing Then
                g.DrawImage(m_Image, m_Position.X, m_Position.Y, m_Size.Width, m_Size.Height)
            End If

        End If
        gr.DrawImage(m_BMP, 0, 0)

        If m_Selector IsNot Nothing Then
            gr.DrawRectangle(Pens.Red, m_Selector.Rectangle.X, m_Selector.Rectangle.Y, m_Selector.Rectangle.Width, m_Selector.Rectangle.Height)
        End If

    End Sub

    Public Sub New()

        ' Dieser Aufruf ist für den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fügen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.
        Me.SetStyle(ControlStyles.DoubleBuffer _
            Or ControlStyles.UserPaint _
            Or ControlStyles.AllPaintingInWmPaint, _
            True)

    End Sub
End Class
