Public Class ZoomPicBox
    Property FileName() As String
        Get
            Return Me.ZoomControl1.BildPfad
        End Get
        Set(ByVal value As String)
            If value = "" Then
                Me.ZoomControl1.BildPfad = ""
                EnableButtons(False)
            Else
                If IO.File.Exists(value) Then
                    Me.ZoomControl1.BildPfad = value
                    EnableButtons(True)
                Else
                    MessageBox.Show("Der angegebene Pfad " & Chr(34) & value & Chr(34) & " existiert nicht.", Application.ProductName, MessageBoxButtons.OK, MessageBoxIcon.Information)
                    Me.ZoomControl1.BildPfad = ""
                    EnableButtons(False)
                End If
            End If
        End Set
    End Property
    Private Sub EnableButtons(ByVal Value As Boolean)
        Me.ToolStripButtonMove.Enabled = Value
        Me.ToolStripButtonZoomOut.Enabled = Value
        Me.ToolStripButtonZoomIn.Enabled = Value
        Me.ToolStripButtonZoomFit.Enabled = Value
        Me.ToolStripButtonZoomPixels.Enabled = Value
        Me.ToolStripButtonProcessColors.Enabled = Value
        Me.ToolStripComboBoxZoom.Enabled = Value
    End Sub


    Private Sub ZoomControl1_ZoomChanged() Handles ZoomControl1.ZoomChanged
        ToolStripComboBoxZoom.Text = ZoomControl1.Zoom.ToString & "%"
    End Sub



    Public Sub New()

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fgen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.
        Me.ToolStripComboBoxZoom.Items.Add("25%")
        Me.ToolStripComboBoxZoom.Items.Add("50%")
        Me.ToolStripComboBoxZoom.Items.Add("75%")
        Me.ToolStripComboBoxZoom.Items.Add("100%")
        Me.ToolStripComboBoxZoom.Items.Add("150%")
        Me.ToolStripComboBoxZoom.Items.Add("200%")
        Me.ToolStripComboBoxZoom.Items.Add("300%")
        Me.ToolStripComboBoxZoom.Items.Add("400%")
    End Sub


    Private Sub ToolStripComboBoxZoom_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ToolStripComboBoxZoom.SelectedIndexChanged
        Dim ZoomWert As Single
        Select Case ToolStripComboBoxZoom.SelectedIndex
            Case 0 : ZoomWert = 25.0F
            Case 1 : ZoomWert = 50.0F
            Case 2 : ZoomWert = 75.0F
            Case 3 : ZoomWert = 100.0F
            Case 4 : ZoomWert = 150.0F
            Case 5 : ZoomWert = 200.0F
            Case 6 : ZoomWert = 300.0F
            Case 7 : ZoomWert = 400.0F

        End Select


        Try
            ZoomControl1.Zoom = ZoomWert
        Catch ex As Exception

        End Try

    End Sub

    Private Sub ToolStripButtonMove_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButtonMove.Click
        Me.ZoomControl1.Mode = PictureControlModes.Hand
        Me.ToolStripButtonMove.Checked = True
        Me.ToolStripButtonZoomIn.Checked = False
        Me.ToolStripButtonZoomOut.Checked = False
    End Sub
    Private Sub ToolStripButtonZoomIn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButtonZoomIn.Click
        ToolStripButtonZoomIn_Aktivieren()
    End Sub
    Private Sub ToolStripButtonZoomIn_Aktivieren()
        Me.ZoomControl1.Mode = PictureControlModes.ZoomIn
        Me.ToolStripButtonMove.Checked = False
        Me.ToolStripButtonZoomIn.Checked = True
        Me.ToolStripButtonZoomOut.Checked = False
    End Sub


    Private Sub ToolStripButtonZoomOut_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButtonZoomOut.Click
        Me.ZoomControl1.Mode = PictureControlModes.ZoomOut
        Me.ToolStripButtonMove.Checked = False
        Me.ToolStripButtonZoomIn.Checked = False
        Me.ToolStripButtonZoomOut.Checked = True
    End Sub

    Private Sub ToolStripButtonZoomFit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButtonZoomFit.Click
        Me.ZoomControl1.FitToControl()
    End Sub

    Private Sub ToolStripButtonZoomPixels_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButtonZoomPixels.Click
        Me.ZoomControl1.ZoomPixels()
    End Sub

    Private Sub ToolStripButtonProcessColors_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButtonProcessColors.Click
        Me.ZoomControl1.EditColors()
    End Sub

    Private Sub ToolStripButtonOpenFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Dim dlg As New OpenFileDialog
        dlg.Filter = "Bilddateien|*.bmp;*.png;*.jpg;*.gif"
        dlg.FilterIndex = 1
        dlg.RestoreDirectory = True

        If dlg.ShowDialog() = Windows.Forms.DialogResult.OK Then
            Me.FileName = dlg.FileName
        End If
    End Sub


    Private Sub ToolStripButtonInfo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Process.Start(Application.StartupPath & "\info.html")
    End Sub
End Class
