Imports System.Xml
Public Class Datensammlung
    Private m_FileName As String = ""


    'Private m_XMLPfad As String = Application.StartupPath & "\Bilddaten.xml"
    Private m_Bilder As New List(Of Bild)
    Private m_Autoren As New List(Of Autor)
    Private m_Datumsangaben As DatumsangabeListe

    Private m_BildGruppen As New List(Of BildGruppe)

    Private m_Webtitel As String = "Fotos"




    ReadOnly Property Datumsangaben() As DatumsangabeListe
        Get
            Return m_Datumsangaben
        End Get
    End Property
    ReadOnly Property Autoren() As List(Of Autor)
        Get
            Return m_Autoren
        End Get
    End Property
    ReadOnly Property Bilder() As List(Of Bild)
        Get
            Return m_Bilder
        End Get
    End Property
    ReadOnly Property BildGruppen() As List(Of BildGruppe)
        Get
            Return m_BildGruppen
        End Get
    End Property
    Property Webtitel() As String
        Get
            Return m_Webtitel
        End Get
        Set(ByVal value As String)
            m_Webtitel = value
        End Set
    End Property

    ReadOnly Property FileName() As String
        Get
            Return m_FileName
        End Get
    End Property
    Public Sub New(ByVal FileName As String)
        m_FileName = FileName
        Init()
    End Sub
    Public Sub New()
        m_FileName = Environment.GetFolderPath(Environment.SpecialFolder.Personal) & "\PhotoCollector\PhotoCollection1\PhotoCollection1.ph_xml"
        Init()
    End Sub
    Private Sub Init()
        BasisPfad = IO.Path.GetDirectoryName(m_FileName)
        If Not IO.Directory.Exists(BasisPfad) Then
            IO.Directory.CreateDirectory(BasisPfad)
        End If

        BildOrdnerPfad = BasisPfad & "\Bilder"
        ThumbOrdnerPfad = BasisPfad & "\Thumbs"
        If Not IO.Directory.Exists(BildOrdnerPfad) Then
            IO.Directory.CreateDirectory(BildOrdnerPfad)
        End If
        If Not IO.Directory.Exists(ThumbOrdnerPfad) Then
            IO.Directory.CreateDirectory(ThumbOrdnerPfad)
        End If


        LoadXML()
        MainBildListe = m_Bilder
        Datumsliste = m_Datumsangaben

        Start_AllThumbCheckThread()
    End Sub



    Private Sub LoadXML()
        If IO.File.Exists(m_FileName) Then
            Dim reader As XmlTextReader = New XmlTextReader(m_FileName)

            reader.WhitespaceHandling = WhitespaceHandling.None
            Dim xmlDoc As XmlDocument = New XmlDocument
            xmlDoc.Load(reader)
            reader.Close()

            Dim xnod As XmlNode = xmlDoc.DocumentElement


            For Each xKn As XmlNode In xnod.ChildNodes
                If xKn.Name = "Datumsangaben" Then
                    m_Datumsangaben = New DatumsangabeListe(xKn, m_Bilder)
                End If
            Next

            If m_Datumsangaben Is Nothing Then
                m_Datumsangaben = New DatumsangabeListe(m_Bilder)
            End If



            For Each xKn As XmlNode In xnod.ChildNodes
                If xKn.Name = "Autoren" Then
                    For Each Nd As XmlNode In xKn.ChildNodes
                        If Nd.Name = "Autor" Then
                            m_Autoren.Add(New Autor(Nd))
                        End If
                    Next
                End If
            Next

            For Each Aut As Autor In m_Autoren
                If Aut.Name = "unbekannt" Then
                    StandardAutor = Aut
                    Exit For
                End If
            Next


            For Each xKn As XmlNode In xnod.ChildNodes
                If xKn.Name = "Bilder" Then
                    For Each Nd As XmlNode In xKn.ChildNodes
                        If Nd.Name = "Bild" Then
                            m_Bilder.Add(New Bild(Nd, m_Autoren, m_Datumsangaben))
                        End If
                    Next
                End If
            Next


            For Each xKn As XmlNode In xnod.ChildNodes
                If xKn.Name = "BildGruppen" Then
                    For Each Nd As XmlNode In xKn.ChildNodes
                        If Nd.Name = "KeyWord" Then
                            m_BildGruppen.Add(New BildGruppe(Nd, m_Bilder))
                        End If
                    Next
                End If
            Next

            For Each xKn As XmlNode In xnod.ChildNodes
                If xKn.Name = "Webtitel" Then
                    m_Webtitel = xKn.Attributes("Text").Value
                End If
            Next


        Else
            If m_Datumsangaben Is Nothing Then
                m_Datumsangaben = New DatumsangabeListe(m_Bilder)
            End If

            Dim Aut0 As New Autor("unbekannt")
            m_Autoren.Add(Aut0)
            StandardAutor = m_Autoren(0)

        End If
    End Sub
    Public Sub Speichern()
        Abort_AllThumbCheckThread()

        Dim writer As XmlTextWriter = New XmlTextWriter(m_FileName, System.Text.Encoding.UTF8)
        writer.WriteStartDocument(True)

        writer.WriteStartElement("Elemente")

        writer.WriteStartElement("Datumsangaben")
        m_Datumsangaben.Write_XML(writer)
        writer.WriteEndElement()

        writer.WriteStartElement("Autoren")
        For Each Aut As Autor In m_Autoren
            writer.WriteStartElement("Autor")
            Aut.Write_XML(writer)
            writer.WriteEndElement()
        Next
        writer.WriteEndElement()


        writer.WriteStartElement("Bilder")
        For Each Bld As Bild In m_Bilder
            writer.WriteStartElement("Bild")
            Bld.Write_XML(writer, m_Autoren, m_Datumsangaben)
            writer.WriteEndElement()
        Next
        writer.WriteEndElement()


        writer.WriteStartElement("BildGruppen")
        For Each BG As BildGruppe In m_BildGruppen
            writer.WriteStartElement("KeyWord")
            BG.Write_XML(writer, m_Bilder)
            writer.WriteEndElement()
        Next
        writer.WriteEndElement()

        writer.WriteStartElement("Webtitel")
        writer.WriteAttributeString("Text", m_Webtitel)
        writer.WriteEndElement()


        writer.WriteEndElement()
        writer.WriteEndDocument()
        writer.Close()
    End Sub

    Public Function NichtZugeordneteBilder() As List(Of Bild)
        Dim Liste As New List(Of Bild)
        Dim Gef As Boolean = False
        For Each Bld As Bild In m_Bilder
            Gef = False
            For Each BG As BildGruppe In m_BildGruppen
                If BG.Contains(Bld) Then
                    Gef = True
                    Exit For
                End If
            Next
            If Not Gef Then
                Liste.Add(Bld)
            End If
        Next
        Return Liste
    End Function


    Public Function FreieBildnummer_Finden() As String
        Dim Dateien() As String = IO.Directory.GetFiles(BildOrdnerPfad)
        Dim Dateinamen As New List(Of String)
        For Each txt As String In Dateien
            Dateinamen.Add(IO.Path.GetFileNameWithoutExtension(txt))
        Next
        Dim Zahl As Integer = 0
        While Dateinamen.Contains(Zahl.ToString)
            Zahl += 1
        End While
        Return Zahl.ToString
    End Function
    Public Sub Bild_Loeschen(ByVal Bld As Bild, ByVal RueckfrageErforderlich As Boolean)
        'Diese Prozedur fhrt zum Entfernen eines Bildes aus allen Listen, in denen es enthalten 
        'ist und zum Lschen der zugehrigen Dateien (im Thumbs- und Bildordner)
        If RueckfrageErforderlich Then
            If MessageBox.Show("Dieses Bild unwiederruflich lschen?", "PhotoCollector", MessageBoxButtons.YesNo, MessageBoxIcon.Warning) = DialogResult.No Then Exit Sub
        End If

        Abort_AllThumbCheckThread()

        Bld.RemoveFromLists()

        For Each BG As BildGruppe In m_BildGruppen
            If BG.Contains(Bld) Then
                BG.Remove(Bld)
            End If
        Next

        m_Bilder.Remove(Bld)
        Bld.RemoveFiles()

        Start_AllThumbCheckThread()
    End Sub
    Public Sub Grafik_Importieren(ByVal Path As String, ByVal ParentForm As Form)
        Dim ProgressForm As New frm_Fortschritt
        'RunAndJoin_AllThumbCheckThread()

        Dim Liste_Hashes As New List(Of Byte())
        Dim IC As New System.Drawing.ImageConverter
        Dim shaM As New Security.Cryptography.SHA256Managed

        Dim TmpBild As Bitmap = Nothing

        Dim btImage() As Byte
        ReDim btImage(0)

        For Each Bld As Bild In m_Bilder
            TmpBild = Image.FromFile(Bld.ThumbFileName)
            btImage = IC.ConvertTo(TmpBild, btImage.GetType)
            Liste_Hashes.Add(shaM.ComputeHash(btImage))
        Next

        Dim TmpListe As New List(Of String)


        Dim Opt As IO.SearchOption = IO.SearchOption.TopDirectoryOnly
        Dim Dirs() As String = IO.Directory.GetDirectories(Path)
        If Dirs.Length > 0 Then
            If MessageBox.Show("Unterverzeichnisse einschliessen?", "PhotoCollector", MessageBoxButtons.YesNo, MessageBoxIcon.Question) = DialogResult.Yes Then Opt = IO.SearchOption.AllDirectories
        End If



        TmpListe.AddRange(IO.Directory.GetFiles(Path, "*.jpg", Opt))
        TmpListe.AddRange(IO.Directory.GetFiles(Path, "*.gif", Opt))
        TmpListe.AddRange(IO.Directory.GetFiles(Path, "*.png", Opt))

        ProgressForm.ProgressBar1.Maximum = TmpListe.Count
        ProgressForm.Show(ParentForm)

        For Each Txt As String In TmpListe
            Dim NeuesBild As New Bild(Txt)
            NeuesBild.FileName = FreieBildnummer_Finden() & IO.Path.GetExtension(Txt)
            IO.File.Copy(Txt, BildOrdnerPfad & "\" & NeuesBild.FileName)

            NeuesBild.CheckCreateThumb(m_Datumsangaben)
            TmpBild = Image.FromFile(NeuesBild.ThumbFileName)

            btImage = IC.ConvertTo(TmpBild, btImage.GetType)
            Dim Erg As Byte() = shaM.ComputeHash(btImage)

            Dim Gef As Boolean = False

            For Each Vgl As Byte() In Liste_Hashes
                If Vgl.Length = Erg.Length Then
                    Dim Ungleich As Boolean = False
                    For I As Integer = 0 To Erg.Length - 1
                        If Vgl(I) <> Erg(I) Then
                            Ungleich = True
                            Exit For
                        End If
                    Next
                    If Not Ungleich Then
                        Gef = True
                        Exit For
                    End If
                End If
            Next
            TmpBild.Dispose()
            If Not Gef Then
                m_Bilder.Add(NeuesBild)
                Liste_Hashes.Add(Erg)
            Else

                IO.File.Delete(NeuesBild.Pfad)
                IO.File.Delete(NeuesBild.ThumbFileName)
            End If
            If ProgressForm.DialogResult <> DialogResult.OK Then
                Exit For
            End If
            ProgressForm.ProgressBar1.Value += 1
            Application.DoEvents()
        Next
        If ProgressForm IsNot Nothing Then
            ProgressForm.Close()
        End If



    End Sub


End Class
