Public Class HTMLExporter
    Private m_DS As Datensammlung
    Public Sub New(ByVal DS As Datensammlung)
        m_DS = DS
    End Sub
    Public Sub Export(ByVal ParentForm As Form)

        'Try
        Dim BildgruppenToPublish As New List(Of BildGruppe)
        Dim BilderToPublish As New List(Of Bild)

        For Each BG As BildGruppe In m_DS.BildGruppen
            If BG.IsToPublish Then
                BildgruppenToPublish.Add(BG)
                For Each Bld As Bild In BG
                    If Not BilderToPublish.Contains(Bld) Then
                        BilderToPublish.Add(Bld)
                    End If
                Next
            End If
        Next

        If BildgruppenToPublish.Count = 0 Then
            MsgBox("Keine Bildgruppen zum Verffentlichen markiert.")
            Exit Sub
        End If


        Dim HTMLPfad As String = BasisPfad & "\HTML"
        Try
            If IO.Directory.Exists(HTMLPfad) Then
                IO.Directory.Delete(HTMLPfad, True)
            End If
        Catch ex As Exception
            MsgBox(ex.Message)
            Exit Sub
        End Try


        Dim Titel As String = InputBox("Web-Titel", "PhotoCollector", m_DS.Webtitel)
        If Titel.Trim <> "" Then
            m_DS.Webtitel = Titel
        Else
            Exit Sub
        End If


        IO.Directory.CreateDirectory(HTMLPfad)
        IO.Directory.CreateDirectory(HTMLPfad & "\images")
        IO.Directory.CreateDirectory(HTMLPfad & "\images\big")
        IO.Directory.CreateDirectory(HTMLPfad & "\images\thumbs")


        Dim PublishBilder As New List(Of PublishBild)
        Dim FriendlyNames As New List(Of String)

        For Each Bld As Bild In BilderToPublish
            PublishBilder.Add(New PublishBild(BildFriendly_Name_Liefern(Bld, FriendlyNames), Thumbsize_Liefern(Bld.Size), Bld))
        Next

        Dim ProgressForm As New frm_Fortschritt
        Dim ExtraExit As Boolean = False

        ProgressForm.ProgressBar1.Maximum = PublishBilder.Count + 1
        ProgressForm.Text = "HTML-Seite exportieren - Fortschritt"
        ProgressForm.Label2.Text = "Ausgewhlte Bildgruppen werden exportiert..."
        ProgressForm.Show(ParentForm)
        ParentForm.Enabled = False

        Dim Extension As String = ""
        For Each PBld As PublishBild In PublishBilder
            Extension = IO.Path.GetExtension(PBld.Bld.Pfad)
            IO.File.Copy(PBld.Bld.Pfad, HTMLPfad & "\images\big\" & PBld.FriendlyName & Extension)

            Thumb_Speichern(PBld, HTMLPfad & "\images\thumbs")
            ProgressForm.ProgressBar1.Value += 1
            If ProgressForm.DialogResult <> DialogResult.OK Then
                ExtraExit = True
                Exit For
            End If
            Application.DoEvents()
        Next

        If ProgressForm IsNot Nothing Then
            ProgressForm.Close()
        End If

        ParentForm.Enabled = True

        If ExtraExit Then

            Try
                If IO.Directory.Exists(HTMLPfad) Then
                    IO.Directory.Delete(HTMLPfad, True)
                End If
            Catch ex As Exception

            End Try
            ParentForm.Activate()
            MsgBox("Erstellung der HTML-Seite wurde abgebrochen.")
            Exit Sub
        End If

        Dim MapZaehler As Integer = 0
        Dim MapString As String = ""

        Dim KnownHTMLFileNames As New List(Of String)
        KnownHTMLFileNames.Add("index")
        KnownHTMLFileNames.Add("left")
        Dim PublishSeiten As New List(Of PublishSeite)
        For Each BG As BildGruppe In BildgruppenToPublish
            PublishSeiten.Add(New PublishSeite(Seitenname_Finden(BG.Word, KnownHTMLFileNames), BG))
        Next

        For Each PS As PublishSeite In PublishSeiten
            Dim SB As New System.Text.StringBuilder
            SB.AppendLine("<html>")
            SB.AppendLine("<head>")
            SB.AppendLine("<meta http-equiv=""Content-Type"" content=""text/html; charset=UTF-8"">")
            SB.AppendLine("<title>")
            SB.AppendLine(PS.BG.Word)
            SB.AppendLine("</title>")
            SB.AppendLine("<link rel=""stylesheet"" type=""text/css"" href=""images/standard.css"">")
            SB.AppendLine("</head>")
            SB.AppendLine("<body>")
            SB.AppendLine("<p class=""seitenueberschrift"">" & PS.BG.Word & "</p>")
            SB.AppendLine("<hr noshade color=""#003366"">")
            SB.AppendLine("<p>" & PS.BG.Description & "</p>")

            SB.AppendLine("<p align=""center"">")

            For Each xBld As Bild In PS.BG
                Dim PBld As PublishBild = Nothing
                For Each ABld As PublishBild In PublishBilder
                    If ABld.Bld Is xBld Then
                        PBld = ABld
                        Exit For
                    End If
                Next

                SB.AppendLine("<div class=""bildabschnitt"">")
                MapString = ""

                If PBld.Bld.Beschriftungen.Count > 0 Then
                    MapZaehler += 1
                    MapString = " usemap=" & Chr(34) & "#map" & MapZaehler.ToString & Chr(34)
                    SB.AppendLine("<div><map name=" & Chr(34) & "map" & MapZaehler.ToString & Chr(34) & ">")
                    For Each RE As BeschriftungsRechteck In PBld.Bld.Beschriftungen
                        Dim Pt(1) As Point
                        Pt(0) = New Point(RE.Rect.X * PBld.Factor, RE.Rect.Y * PBld.Factor)
                        Pt(1) = New Point((RE.Rect.X + RE.Rect.Width) * PBld.Factor, (RE.Rect.Y + RE.Rect.Height) * PBld.Factor)

                        Dim KoordinatenString As String = Pt(0).X.ToString & "," & Pt(0).Y.ToString & "," & Pt(1).X.ToString & "," & Pt(1).Y.ToString

                        SB.AppendLine("<area shape=""rect"" coords=" & Chr(34) & KoordinatenString & Chr(34) & " alt=" & Chr(34) & RE.Text & Chr(34) & ">")
                    Next
                    SB.AppendLine("</map></div>")
                End If

                SB.AppendLine("<div class=""bildrahmen"">")
                SB.AppendLine("<img border=""0"" src=""images/Thumbs/" & PBld.FriendlyName & ".jpg" & Chr(34) & " width=" & Chr(34) & PBld.ThumbSize.Width.ToString & Chr(34) & " height=" & Chr(34) & PBld.ThumbSize.Height.ToString & Chr(34) & MapString & "></div>")
                SB.AppendLine(PBld.Bld.Beschreibung)
                Dim DA As String = PBld.Bld.Datumsangabe.ToString
                If DA = "unbekannt" Then DA = "-"
                SB.AppendLine("<br><span class=""smallsilvertext"">" & DA)
                SB.AppendLine(QuellHTML_Liefern(PBld.Bld))
                SB.AppendLine("</span></div>")

            Next
            SB.AppendLine("</p>")


            SB.AppendLine("</body>")
            SB.AppendLine("</html>")


            Using Writer As New System.IO.StreamWriter(HTMLPfad & "\" & PS.FriendlyName & ".htm", False, System.Text.Encoding.UTF8)
                Writer.Write(SB.ToString)
                Writer.Close()
            End Using

        Next

        LinkeFrameSeiteSchreiben(HTMLPfad & "\uebersicht.htm", PublishSeiten)
        WriteIndex(HTMLPfad & "\index.htm", PublishSeiten(0))

        WriteCSS(HTMLPfad & "\images\standard.css")

        Process.Start(HTMLPfad & "\index.htm")

        'Catch ex As Exception
        '    MsgBox(ex.Message)
        'End Try

        ParentForm.Enabled = True
        ParentForm.Activate()
    End Sub

    Private Sub LinkeFrameSeiteSchreiben(ByVal Pfad As String, ByVal Seiten As List(Of PublishSeite))

        Dim SB As New System.Text.StringBuilder
        SB.AppendLine("<html>")
        SB.AppendLine("<head>")
        SB.AppendLine("<meta http-equiv=""Content-Type"" content=""text/html; charset=UTF-8"">")
        SB.AppendLine("<title>")
        SB.AppendLine("Uebersicht")
        SB.AppendLine("</title>")
        SB.AppendLine("<link rel=""stylesheet"" type=""text/css"" href=""images/standard.css"">")
        SB.AppendLine("<base target=""Hauptframe"">")

        SB.AppendLine("</head>")
        SB.AppendLine("<body>")

        SB.AppendLine("<p>")
        For Each PS As PublishSeite In Seiten
            SB.AppendLine("<a class=""blaulink"" href=" & Chr(34) & PS.FriendlyName & ".htm" & Chr(34) & ">" & PS.BG.Word & "</a><br>")


        Next
        SB.AppendLine("</p>")
        SB.AppendLine("</body>")
        SB.AppendLine("</html>")


        Using Writer As New System.IO.StreamWriter(Pfad, False, System.Text.Encoding.UTF8)
            Writer.Write(SB.ToString)
            Writer.Close()
        End Using


    End Sub

    Private Sub WriteCSS(ByVal Pfad As String)
        Using Writer As New System.IO.StreamWriter(Pfad)
            Writer.WriteLine("body, table, td, tr, div, p, pre, h1, h2, h3, h4, ul")
            Writer.WriteLine("{")
            Writer.WriteLine("color: #003366;")
            Writer.WriteLine("font-family: Arial, Helvetica, sans-serif;")
            Writer.WriteLine("font-size: 12px;")
            Writer.WriteLine("}")

            Writer.WriteLine(".seitenueberschrift")
            Writer.WriteLine("{")
            Writer.WriteLine("font-size: 18px;")
            Writer.WriteLine("}")


            Writer.WriteLine("A.blaulink:link")
            Writer.WriteLine("{")
            Writer.WriteLine("font-weight: bold;")
            Writer.WriteLine("color: #003366;")
            Writer.WriteLine("text-decoration: none;")
            Writer.WriteLine("}")

            Writer.WriteLine("A.blaulink:visited")
            Writer.WriteLine("{")
            Writer.WriteLine("font-weight: bold;")
            Writer.WriteLine("color: #003366;")
            Writer.WriteLine("text-decoration: none;")
            Writer.WriteLine("}")

            Writer.WriteLine("A.blaulink:active")
            Writer.WriteLine("{")
            Writer.WriteLine("font-weight: bold;")
            Writer.WriteLine("color: #ff9900;")
            Writer.WriteLine("text-decoration: none;")
            Writer.WriteLine("}")

            Writer.WriteLine("A.blaulink:hover")
            Writer.WriteLine("{")
            Writer.WriteLine("font-weight: bold;")
            Writer.WriteLine("background: #003366;")
            Writer.WriteLine("color: white;")
            Writer.WriteLine("text-decoration: none;")
            Writer.WriteLine("}")

            Writer.WriteLine(".smallsilvertext")
            Writer.WriteLine("{")
            Writer.WriteLine("font-size: 10px;")
            Writer.WriteLine("color: silver;")
            Writer.WriteLine("line-height:12px;")
            Writer.WriteLine("}")

            Writer.WriteLine("A.silverlink:link")
            Writer.WriteLine("{")
            Writer.WriteLine("font-size: 10px;")
            Writer.WriteLine("font-weight: bold;")
            Writer.WriteLine("color: silver;")
            Writer.WriteLine("text-decoration: none;")
            Writer.WriteLine("}")

            Writer.WriteLine("A.silverlink:visited")
            Writer.WriteLine("{")
            Writer.WriteLine("font-size: 10px;")
            Writer.WriteLine("font-weight: bold;")
            Writer.WriteLine("color: silver;")
            Writer.WriteLine("text-decoration: none;")
            Writer.WriteLine("}")

            Writer.WriteLine("A.silverlink:active")
            Writer.WriteLine("{")
            Writer.WriteLine("font-size: 10px;")
            Writer.WriteLine("font-weight: bold;")
            Writer.WriteLine("color: #ff9900;")
            Writer.WriteLine("text-decoration: none;")
            Writer.WriteLine("}")

            Writer.WriteLine("A.silverlink:hover")
            Writer.WriteLine("{")
            Writer.WriteLine("font-size: 10px;")
            Writer.WriteLine("font-weight: bold;")
            Writer.WriteLine("background: silver;")
            Writer.WriteLine("color: white;")
            Writer.WriteLine("text-decoration: none;")
            Writer.WriteLine("}")

            Writer.WriteLine(".bildabschnitt")
            Writer.WriteLine("{")
            Writer.WriteLine("text-align:center;")
            Writer.WriteLine("float:left; ")
            Writer.WriteLine("margin:10px;")
            Writer.WriteLine("}")


            Writer.WriteLine(".bildrahmen")
            Writer.WriteLine("{")
            Writer.WriteLine("width=100px;")
            Writer.WriteLine("border: 1px solid silver;")
            Writer.WriteLine("padding: 10px;")
            Writer.WriteLine("}")


            Writer.Close()
        End Using
    End Sub

    Private Sub WriteIndex(ByVal Pfad As String, ByVal startseite As PublishSeite)
        Dim SB As New System.Text.StringBuilder
        SB.AppendLine("<html>")
        SB.AppendLine("<head>")
        SB.AppendLine("<meta http-equiv=""Content-Type"" content=""text/html; charset=UTF-8"">")
        SB.AppendLine("<title>")
        SB.AppendLine(m_DS.Webtitel)
        SB.AppendLine("</title>")
        SB.AppendLine("<link rel=""stylesheet"" type=""text/css"" href=""images/standard.css"">")
        SB.AppendLine("</head>")

        SB.AppendLine("<frameset cols=""223,*"" frameborder=""0"" framespacing=""0"" border=""0"">")
        SB.AppendLine("<frame name=""Inhalt"" target=""Hauptframe"" src=""uebersicht.htm"">")
        SB.AppendLine("<frame name=""Hauptframe"" src=" & Chr(34) & startseite.FriendlyName & ".htm" & Chr(34) & ">")
        SB.AppendLine("<noframes>")
        SB.AppendLine("<body>")

        SB.AppendLine("<p>Diese Seite verwendet Frames. Frames werden von Ihrem Browser aber nicht untersttzt.</p>")

        SB.AppendLine("</body>")
        SB.AppendLine("</noframes>")
        SB.AppendLine("</frameset>")

        SB.AppendLine("</html>")

        Using Writer As New System.IO.StreamWriter(Pfad, False, System.Text.Encoding.UTF8)
            Writer.Write(SB.ToString)
            Writer.Close()
        End Using


    End Sub

    Private Function BildFriendly_Name_Liefern(ByVal Bld As Bild, ByVal KnownNames As List(Of String)) As String
        Dim TmpName As String = Bld.Beschreibung.Trim
        If TmpName = "" Then
            TmpName = IO.Path.GetFileNameWithoutExtension(Bld.Pfad)
        End If

        TmpName = HTMLNameErsatz(TmpName)

        If Not KnownNames.Contains(TmpName) Then
            KnownNames.Add(TmpName)
            Return TmpName
        End If

        Dim ZName As String = ""
        Dim Zaehler As Integer = 0
        While True
            ZName = TmpName & Zaehler.ToString
            If Not KnownNames.Contains(ZName) Then
                KnownNames.Add(ZName)
                Return ZName
            End If
            Zaehler += 1
        End While
        Return ""
    End Function
    Private Function HTMLNameErsatz(ByVal Orig As String) As String
        Dim TmpText As String = Orig.ToLower
        Dim chars() As Char = TmpText.ToCharArray

        Dim ErgText As String = ""
        For Each x As Char In chars
            If Char.IsLetter(x) Then
                ErgText &= x
            Else
                ErgText &= "_"
            End If
        Next



        ErgText = ErgText.Replace("__", "_")
        ErgText = ErgText.Replace("", "ae")
        ErgText = ErgText.Replace("", "oe")
        ErgText = ErgText.Replace("", "ue")
        ErgText = ErgText.Replace("", "ss")
        Return ErgText
    End Function

    Private Sub Thumb_Speichern(ByVal PBld As PublishBild, ByVal ThumbDir As String)
        If PBld.ThumbSize <> PBld.Bld.Size Then
            'Dim NewRect As Rectangle = GetPictureRectangle(New Rectangle(0, 0, 400, 400), Img.Size)
            Dim Img As Image = Image.FromFile(PBld.Bld.Pfad)
            Dim Thumb As New Bitmap(PBld.ThumbSize.Width, PBld.ThumbSize.Height)
            Dim g As Graphics = Graphics.FromImage(Thumb)
            g.DrawImage(Img, New Rectangle(0, 0, PBld.ThumbSize.Width, PBld.ThumbSize.Height))

            Dim enc As Imaging.ImageCodecInfo = Nothing
            Dim Infos() As Imaging.ImageCodecInfo = Imaging.ImageCodecInfo.GetImageEncoders
            For Each Inf As Imaging.ImageCodecInfo In Infos
                If Inf.MimeType.ToLower = "image/jpeg" Then
                    enc = Inf
                    Exit For
                End If
            Next
            Dim Params As New Imaging.EncoderParameters(1)
            Params.Param(0) = New Imaging.EncoderParameter(Imaging.Encoder.Quality, 50L)
            Thumb.Save(ThumbDir & "\" & PBld.FriendlyName & ".jpg", enc, Params)
            Thumb.Dispose()
            Img.Dispose()
        Else
            Dim Img As Image = Image.FromFile(PBld.Bld.Pfad)
            Dim enc As Imaging.ImageCodecInfo = Nothing
            Dim Infos() As Imaging.ImageCodecInfo = Imaging.ImageCodecInfo.GetImageEncoders
            For Each Inf As Imaging.ImageCodecInfo In Infos
                If Inf.MimeType.ToLower = "image/jpeg" Then
                    enc = Inf
                    Exit For
                End If
            Next
            Dim Params As New Imaging.EncoderParameters(1)
            Params.Param(0) = New Imaging.EncoderParameter(Imaging.Encoder.Quality, 50L)
            Img.Save(ThumbDir & "\" & PBld.FriendlyName & ".jpg", enc, Params)
            Img.Dispose()
        End If

    End Sub
    Private Function Thumbsize_Liefern(ByVal OrigSize As Size) As SizeWithFactor
        'Das Thumbnail soll so skaliert werden, dass die krzere Kantenlnge 400 ist
        Return Get400Size(OrigSize)

    End Function

    Private Function Get400Size(ByVal OrigSize As Size) As SizeWithFactor
        Dim KuerzereSeite As Double = CDbl(OrigSize.Width)
        If CDbl(OrigSize.Height) < KuerzereSeite Then KuerzereSeite = CDbl(OrigSize.Height)
        Dim Factor As Double = 400.0R / KuerzereSeite

        Return New SizeWithFactor(OrigSize.Width * Factor, OrigSize.Height * Factor, Factor)

    End Function

    Private Function Seitenname_Finden(ByVal OrigName As String, ByVal KnownNames As List(Of String)) As String
        Dim TmpName As String = OrigName.Trim
        TmpName = HTMLNameErsatz(TmpName)

        If Not KnownNames.Contains(TmpName) Then
            KnownNames.Add(TmpName)
            Return TmpName
        End If

        Dim ZName As String = ""
        Dim Zaehler As Integer = 0
        While True
            ZName = TmpName & Zaehler.ToString
            If Not KnownNames.Contains(ZName) Then
                KnownNames.Add(ZName)
                Return ZName
            End If
            Zaehler += 1
        End While
        Return ""
    End Function

    Private Class PublishBild
        Private m_FriendlyName As String = ""
        Private m_ThumbSize As Size
        Private m_Bld As Bild
        Private m_Factor As Double
        ReadOnly Property FriendlyName() As String
            Get
                Return m_FriendlyName
            End Get
        End Property
        ReadOnly Property ThumbSize() As Size
            Get
                Return m_ThumbSize
            End Get
        End Property
        ReadOnly Property Bld() As Bild
            Get
                Return m_Bld
            End Get
        End Property
        ReadOnly Property Factor() As Double
            Get
                Return m_Factor
            End Get
        End Property
        Public Sub New(ByVal FriendlyName As String, ByVal ThumbSize As SizeWithFactor, ByVal Bld As Bild)
            m_FriendlyName = FriendlyName
            m_ThumbSize = New Size(ThumbSize.Width, ThumbSize.Height)
            m_Bld = Bld
            m_Factor = ThumbSize.Factor
        End Sub
    End Class
    Private Class PublishSeite
        Private m_FriendlyName As String = ""
        Private m_BG As BildGruppe
        ReadOnly Property FriendlyName() As String
            Get
                Return m_FriendlyName
            End Get
        End Property
        ReadOnly Property BG() As BildGruppe
            Get
                Return m_BG
            End Get
        End Property
        Public Sub New(ByVal FriendlyName As String, ByVal BG As BildGruppe)
            m_FriendlyName = FriendlyName
            m_BG = BG
        End Sub
    End Class
    Private Function QuellHTML_Liefern(ByVal Bld As Bild)
        Dim AutorAbschnitt As String = ""
        Dim QuellNrAbschnitt As String = ""

        If Bld.Autor.Name <> "unbekannt" Then
            If Bld.Autor.Link <> "" Then
                AutorAbschnitt = "<a class=""silverlink"" target=""_blank"" href=" & Chr(34) & Bld.Autor.Link & Chr(34) & ">" & Bld.Autor.Name & "</a>"
            Else
                AutorAbschnitt = Bld.Autor.Name
            End If
        End If


        If Bld.QuellIndex <> "" Then
            QuellNrAbschnitt = "Foto-Nr. " & Bld.QuellIndex
        End If

        If AutorAbschnitt <> "" AndAlso QuellNrAbschnitt <> "" Then
            Return "<br>Quelle: " & AutorAbschnitt & ", " & QuellNrAbschnitt
        ElseIf AutorAbschnitt <> "" Then
            Return "<br>Quelle: " & AutorAbschnitt
        Else
            Return ""
        End If


    End Function
    Private Class SizeWithFactor
        Private m_Width As Integer
        Private m_Height As Integer
        Private m_Factor As Double
        Public Sub New(ByVal Width As Integer, ByVal Height As Integer, ByVal Factor As Double)
            m_Width = Width
            m_Height = Height
            m_Factor = Factor
        End Sub
        ReadOnly Property Width() As Integer
            Get
                Return m_Width
            End Get
        End Property
        ReadOnly Property Height() As Integer
            Get
                Return m_Height
            End Get
        End Property
        ReadOnly Property Factor() As Double
            Get
                Return m_Factor
            End Get
        End Property
    End Class
End Class
