Public Class frm_Main
    Private m_DS As Datensammlung
    Private WithEvents SourceCombo As ToolStripComboBox
    Private WithEvents SourceGruppenCombo As ToolStripComboBox
    Private ExtraSeparator As ToolStripSeparator

    Private Sub frm_BildgruppenBearbeiten_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        m_DS.Speichern()
    End Sub

    Private Sub frm_Main_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim AD As New Anwendungsdaten
        AD.Icon_Verknpfung_herstellen()

        Dim StartPfad As String = ""

        Dim CommandLine As String = ""

        For Each txt As String In My.Application.CommandLineArgs
            CommandLine &= " " & txt
        Next

        CommandLine = CommandLine.Trim

        'If My.Application.CommandLineArgs.Count > 0 Then
        '    For I As Integer = 0 To My.Application.CommandLineArgs.Count - 1
        '        MsgBox("*" & My.Application.CommandLineArgs(I) & "*")
        '    Next
        'End If


        If CommandLine.IndexOf("/open/") > -1 Then
            StartPfad = AD.GetLongFilename(CommandLine.Substring(0, CommandLine.IndexOf("/open/")))
        End If




        If StartPfad = "" Then
            m_DS = New Datensammlung
        Else
            m_DS = New Datensammlung(StartPfad)
        End If

        Me.Text = "PhotoCollector - " & IO.Path.GetFileNameWithoutExtension(m_DS.FileName)


        Me.SortOptionZoomListViewSource.DS = m_DS
        Me.SortOptionZoomListViewZiel.DS = m_DS

        Me.BildeigenschaftsEditor1.Init(m_DS)
        Me.BildGruppenSelector1.Init(m_DS.BildGruppen)


        SourceCombo = New ToolStripComboBox
        SourceCombo.Items.Add("Alle Bilder")
        SourceCombo.Items.Add("Bildgruppen")
        SourceCombo.Items.Add("Nicht zugeordnet")

        SourceCombo.Size = New Size(100, 25)
        Dim Lbl As New ToolStripLabel
        Lbl.Text = "Quelle"
        Me.SortOptionZoomListViewSource.ToolStrip1.Items.Add(New ToolStripSeparator)
        Me.SortOptionZoomListViewSource.ToolStrip1.Items.Add(Lbl)
        Me.SortOptionZoomListViewSource.ToolStrip1.Items.Add(SourceCombo)

        SourceGruppenCombo = New ToolStripComboBox
        For Each BG As BildGruppe In m_DS.BildGruppen
            SourceGruppenCombo.Items.Add(BG)
        Next
        SourceGruppenCombo.Visible = False
        ExtraSeparator = New ToolStripSeparator

        ExtraSeparator.Visible = False
        Me.SortOptionZoomListViewSource.ToolStrip1.Items.Add(ExtraSeparator)
        Me.SortOptionZoomListViewSource.ToolStrip1.Items.Add(SourceGruppenCombo)

        SourceCombo.SelectedIndex = 0
    End Sub


    Private m_SelectedBilder As List(Of Bild)
    Private Sub SetSelectedBilder(ByVal NewBilder As List(Of Bild))
        Dim AenderungNotwendig As Boolean = False
        If m_SelectedBilder Is Nothing Then
            AenderungNotwendig = True
        ElseIf m_SelectedBilder.Count <> NewBilder.Count Then
            AenderungNotwendig = True
        ElseIf m_SelectedBilder.Count > 0 Then
            For I As Integer = 0 To m_SelectedBilder.Count - 1
                If m_SelectedBilder(I) IsNot NewBilder(I) Then
                    AenderungNotwendig = True
                    Exit For
                End If
            Next
        End If
        If AenderungNotwendig Then
            m_SelectedBilder = NewBilder
            If m_SelectedBilder.Count = 0 Then
                Me.ZoomBeschriftungsPicBox1.Bild = Nothing
            Else
                Me.ZoomBeschriftungsPicBox1.Bild = m_SelectedBilder(0)
            End If
            Me.BildeigenschaftsEditor1.Bilder = m_SelectedBilder
        End If
    End Sub

    Private Sub SourceCombo_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles SourceCombo.SelectedIndexChanged
        Select Case SourceCombo.SelectedIndex
            Case 0
                SourceGruppenCombo.Visible = False
                ExtraSeparator.Visible = False
            Case 1
                SourceGruppenCombo.Visible = True
                ExtraSeparator.Visible = True
                If SourceGruppenCombo.Items.Count > 0 Then
                    If SourceGruppenCombo.SelectedIndex = -1 Then
                        SourceGruppenCombo.SelectedIndex = 0
                    End If
                End If
            Case 2
                SourceGruppenCombo.Visible = False
                ExtraSeparator.Visible = False
        End Select
        SourceAenderung()
    End Sub
    Private Sub SourceGruppenCombo_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles SourceGruppenCombo.SelectedIndexChanged
        SourceAenderung()
    End Sub

    Private Sub SourceAenderung()
        Select Case SourceCombo.SelectedIndex
            Case 0
                Me.SortOptionZoomListViewSource.Bilder = m_DS.Bilder
            Case 1
                If SourceGruppenCombo.SelectedIndex > -1 Then
                    Me.SortOptionZoomListViewSource.Bilder = SourceGruppenCombo.SelectedItem
                Else
                    Me.SortOptionZoomListViewSource.Bilder = Nothing
                End If
            Case 2
                Me.SortOptionZoomListViewSource.Bilder = m_DS.NichtZugeordneteBilder
        End Select
    End Sub


    Private Sub BildGruppenSelector1_SelectedBildgruppe_Changed(ByVal SelectedBildgruppe As BildGruppe) Handles BildGruppenSelector1.SelectedBildgruppe_Changed
        Me.BildgruppenEigenschaftseditor1.BildGruppe = SelectedBildgruppe
        Me.SortOptionZoomListViewZiel.Bilder = SelectedBildgruppe

        If SourceGruppenCombo Is Nothing Then Exit Sub

        'SourceGruppenCombo
        For Each BG As BildGruppe In m_DS.BildGruppen
            If Not SourceGruppenCombo.Items.Contains(BG) Then
                SourceGruppenCombo.Items.Insert(m_DS.BildGruppen.IndexOf(BG), BG)
            End If
        Next



        If SelectedBildgruppe Is Nothing Then Exit Sub
        If SourceGruppenCombo.Items.Contains(SelectedBildgruppe) Then
            SourceGruppenCombo.Items.Remove(SelectedBildgruppe)
            If SourceGruppenCombo.SelectedIndex = -1 Then
                If SourceGruppenCombo.Items.Count > 0 Then
                    SourceGruppenCombo.SelectedIndex = 0
                End If
            End If
        End If


    End Sub


    Private Sub SortOptionZoomListViewSource_SelectedBilder_Geaendert() Handles SortOptionZoomListViewSource.SelectedBilder_Geaendert
        Dim NeueListe As List(Of Bild) = SortOptionZoomListViewSource.SelectedBilder
        If NeueListe.Count > 0 Then
            SetSelectedBilder(NeueListe)
        Else
            Dim AndereListe As List(Of Bild) = SortOptionZoomListViewZiel.SelectedBilder
            If AndereListe.Count > 0 Then
                SetSelectedBilder(AndereListe)
            Else
                SetSelectedBilder(New List(Of Bild))
            End If
        End If
    End Sub

    Private Sub SortOptionZoomListViewZiel_SelectedBilder_Geaendert() Handles SortOptionZoomListViewZiel.SelectedBilder_Geaendert
        Dim NeueListe As List(Of Bild) = SortOptionZoomListViewZiel.SelectedBilder
        If NeueListe.Count > 0 Then
            SetSelectedBilder(NeueListe)
        Else
            Dim AndereListe As List(Of Bild) = SortOptionZoomListViewSource.SelectedBilder
            If AndereListe.Count > 0 Then
                SetSelectedBilder(AndereListe)
            Else
                SetSelectedBilder(New List(Of Bild))
            End If
        End If
    End Sub

    Private Sub ToolStripButtonBilderImportieren_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButtonBilderImportieren.Click
        Dim Dlg As New FolderBrowserDialog
        If Dlg.ShowDialog = Windows.Forms.DialogResult.OK Then
            m_DS.Grafik_Importieren(Dlg.SelectedPath, Me)
            If SourceCombo.SelectedIndex = 0 Then
                SourceAenderung()
            Else
                SourceCombo.SelectedIndex = 0
            End If
        End If

    End Sub

    Private m_HTMLExporter As HTMLExporter = Nothing
    Private Sub ToolStripButtonHTMLErstellen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButtonHTMLErstellen.Click
        If m_HTMLExporter Is Nothing Then
            m_HTMLExporter = New HTMLExporter(m_DS)
            m_HTMLExporter.Export(Me)
            m_HTMLExporter = Nothing
        End If
    End Sub


    Private Sub ToolStripButtonInfo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButtonInfo.Click
        Process.Start(Application.StartupPath & "\info.html")
    End Sub
End Class